\NeedsTeXFormat{LaTeX2e}
\ProvidesClass{jmsj}[2023/04/12 v1.3.0 class for Journal of Mathematical Society of Japan^^J]
\DeclareOption{a4paper}{\paperheight 297mm \paperwidth 210mm}
\DeclareOption{a4j}{\paperheight 297mm \paperwidth 210mm}
\DeclareOption{letterpaper}{\paperheight 11in \paperwidth 8.5in}
\DeclareOption{b5paper}{\paperheight 257mm \paperwidth 182mm}
\DeclareOption{b5j}{\paperheight 257mm \paperwidth 182mm}
\DeclareOption{landscape}{%
   \ClassWarningNoLine{jmsj}{``Landscape'' orientation is not supported.}}
\DeclareOption{portrait}{}
\DeclareOption{oneside}{\@twosidefalse \@mparswitchfalse}
\DeclareOption{twoside}{\@twosidetrue  \@mparswitchtrue}
\DeclareOption{draft}{\overfullrule5\p@}
\DeclareOption{final}{\overfullrule\z@ }
\newif\if@publish \@publishfalse
\DeclareOption{publish}{\overfullrule\z@ \@publishtrue}
\newif\if@titlepage
\DeclareOption{titlepage}{\@titlepagetrue}
\DeclareOption{notitlepage}{\@titlepagefalse}
\DeclareOption{onecolumn}{\@twocolumnfalse}
\DeclareOption{twocolumn}{\@twocolumntrue}
\DeclareOption{nomath}{}
\DeclareOption{nothm}{}
\DeclareOption{noamsfonts}{}
\DeclareOption{psamsfonts}{%
   \PassOptionsToPackage{psamsfonts}{amsfonts}%
   \PassOptionsToPackage{cmex10}{amsmath}}
\newif\iftagsleft@
\DeclareOption{leqno}{%
   \tagsleft@true \PassOptionsToPackage{leqno}{amsmath}}
\DeclareOption{reqno}{%
   \tagsleft@false \PassOptionsToPackage{reqno}{amsmath}}
\newif\ifctagsplit@
\DeclareOption{centertags}{%
   \ctagsplit@true \PassOptionsToPackage{centertags}{amsmath}}
\DeclareOption{tbtags}{%
   \ctagsplit@false \PassOptionsToPackage{tbtags}{amsmath}}
\DeclareOption{fleqn}{}%
\def\@ptsize{0}
\DeclareOption{10pt}{}
\DeclareOption{11pt}{\ClassWarningNoLine{jmsj}{In JMSJ, \string\normalsize\space is 10pt.}}%
\DeclareOption{12pt}{\ClassWarningNoLine{jmsj}{In JMSJ, \string\normalsize\space is 10pt.}}%
\DeclareOption{8pt}{\ClassWarningNoLine{jmsj}{In JMSJ, \string\normalsize\space is 10pt.}}
\DeclareOption{9pt}{\ClassWarningNoLine{jmsj}{In JMSJ, \string\normalsize\space is 10pt.}}
\DeclareOption{makeidx}{}
\newif\if@UseLineno\DeclareOption{lineno}{\@UseLinenotrue}\DeclareOption{nolineno}{\@UseLinenofalse}% v1.3: added
\ExecuteOptions{reqno,centertags,a4paper,portrait,10pt,twoside,onecolumn,final}
\ProcessOptions\relax
%
%%% utility
\def\@oparg#1[#2]{\@ifnextchar[{#1}{#1[#2]}}
\begingroup \catcode`\ =12
\gdef\@redef@ifempty{%
\long\gdef\@ifempty##1{\@ifempty@##1  ..\@nil}
\long\gdef\@ifempty@##1##2 ##3##4##5\@nil{%
\ifx##3##4\expandafter\@firstoftwo\else\expandafter\@secondoftwo\fi}}%
\endgroup
\AtBeginDocument{\@redef@ifempty}
\long\def\@ifnotempty#1{\@ifempty{#1}{}}
%
\def\@addpunct#1{%
   \relax
   \ifhmode \ifnum\spacefactor>\@m \else#1\fi \fi}
\def\nopunct{\spacefactor 1007 }
\def\frenchspacing{\sfcode`\.1006\sfcode`\?1005\sfcode`\!1004%
   \sfcode`\:1003\sfcode`\;1002\sfcode`\,1001 }
%
\newcommand*{\larger}[1][1]{%
  \count@\@currsizeindex \advance\count@#1\relax
  \ifnum\count@<\z@ \count@\z@ \else\ifnum\count@>12 \count@12 \fi\fi
  \ifcase\count@
    \Tiny\or\Tiny\or\tiny\or\SMALL\or\Small\or\small
    \or\normalsize
    \or\large\or\Large\or\LARGE\or\huge\or\Huge\else\Huge
  \fi}
\newcommand*{\smaller}[1][1]{\larger[-#1]}
\def\@xsetfontsize#1#2{%
   \chardef\@currsizeindex#2\relax
   \@setfontsize#1}
\chardef\@currsizeindex=6
\DeclareRobustCommand*{\normalsize}{%
%%	   \@xsetfontsize\normalsize{6}{10}{13}%
   \@xsetfontsize\normalsize{6}{10}{4.5mm}% v1.3: changed
   \abovedisplayskip 10\p@
   \abovedisplayshortskip 10\p@
   \belowdisplayshortskip \abovedisplayshortskip
   \belowdisplayskip \abovedisplayskip
   \let\@listi\@listI}
\normalsize
\sloppy
\DeclareRobustCommand*{\Tiny}{\@xsetfontsize\Tiny{1}{5}{7}}
\DeclareRobustCommand*{\tiny}{\@xsetfontsize\tiny{2}{5}{7}}
\DeclareRobustCommand*{\SMALL}{\@xsetfontsize\SMALL{3}{7}{8}}
\DeclareRobustCommand*{\Small}{%
   \@xsetfontsize\Small{4}{8}{10}%
   \abovedisplayskip 3\p@
   \abovedisplayshortskip 3\p@
   \belowdisplayshortskip \abovedisplayshortskip
   \def\@listi{\leftmargin\leftmargini
               \topsep 3\p@ \@plus\p@ \@minus\p@
               \parsep 2\p@ \@plus\p@ \@minus\p@
               \itemsep \parsep}%
   \belowdisplayskip \abovedisplayskip}
\DeclareRobustCommand{\small}{%
   \@xsetfontsize\small{5}{9}{11}%
   \abovedisplayskip 5\p@
   \abovedisplayshortskip 5\p@
   \belowdisplayshortskip \abovedisplayshortskip
   \def\@listi{\leftmargin\leftmargini
               \topsep 4\p@ \@plus2\p@ \@minus2\p@
               \parsep 2\p@ \@plus\p@ \@minus\p@
               \itemsep \parsep}%
   \belowdisplayskip \abovedisplayskip}
\def\footnotesize{\Small}
\def\scriptsize{\SMALL}
\DeclareRobustCommand*{\large}{\@xsetfontsize\large{7}\@xiipt{17}}
\DeclareRobustCommand*{\Large}{\@xsetfontsize\Large{8}\@xivpt{21}}
\DeclareRobustCommand*{\LARGE}{\@xsetfontsize\LARGE{9}\@xviipt{25}}
\DeclareRobustCommand*{\huge}{\@xsetfontsize\huge{10}\@xxpt{28}}
\DeclareRobustCommand*{\Huge}{\@xsetfontsize\Huge{11}\@xxvpt{33}}
\widowpenalty\@m
\clubpenalty\@m
\brokenpenalty\@m
\lineskip\p@
\lineskiplimit\p@
\normallineskip\p@
\normallineskiplimit\p@
\def\baselinestretch{}%%% single space
\topskip    = 10pt
\headheight = 3mm
\headsep    = 5.5mm
\footskip   = 12pt
%%	\textheight = 600.5pt %%% 210mm + (\topskip - (standard height of a ``normal'' line))
%%	                      %%% 210mm = ``nominal'' height of text-area
\textheight = 202mm % v1.3: changed
\textwidth  = 135mm
%
\dimen@\paperwidth
\advance\dimen@-\textwidth
\divide\dimen@\tw@
\advance\dimen@-1in
\oddsidemargin \dimen@
\evensidemargin\dimen@
\dimen@\paperheight
\advance\dimen@ 210mm\relax%%% 210mm = ``nominal'' height of text-area
\divide\dimen@\tw@
\advance\dimen@-\textheight
\advance\dimen@-\headheight
\advance\dimen@-\headsep
\advance\dimen@-1in
\topmargin\dimen@
% v1.3: added
\advance\topmargin-9mm
%%	\advance\oddsidemargin+3.6mm
%%	\advance\evensidemargin-3.6mm
%
\predisplaypenalty=0
\postdisplaypenalty=0
%
\columnsep  = 10pt
\columnseprule = 0pt
\marginparwidth = 60pt
\marginparsep  = 10pt
\marginparpush = 5pt
\AtBeginDocument{\settoheight{\footnotesep}{\footnotesize M$^1$}}
\skip\footins    = 9pt plus 4pt
\skip\@mpfootins = \skip\footins
\fboxsep=3pt
\fboxrule=.4pt
\arrayrulewidth=.4pt
\doublerulesep=2pt
\labelsep=5pt
\arraycolsep\p@
\tabcolsep=\labelsep    \tabbingsep=\labelsep
\floatsep     = 12\p@ \@plus 2\p@ \@minus 2\p@
\textfloatsep = 20\p@ \@plus 2\p@ \@minus 4\p@
\intextsep    = 12\p@ \@plus 2\p@ \@minus 2\p@
\dblfloatsep  =    12\p@ \@plus 2\p@ \@minus 2\p@
\dbltextfloatsep = 20\p@ \@plus 2\p@ \@minus 4\p@
\@fptop = 0\p@ \@plus 1fil
\@fpsep = 8\p@ \@plus 2fil
\@fpbot = 0\p@ \@plus 1fil
\@dblfptop = 0\p@ \@plus 1fil
\@dblfpsep = 8\p@ \@plus 2fil
\@dblfpbot = 0\p@ \@plus 1fil
\parskip=0pt \@plus \p@
\newdimen\normalparindent
%%	\normalparindent=15pt
\normalparindent=20pt % v1.3: changed
\parindent=\normalparindent
\if@twocolumn
   \leftmargini = 2em
\else
   \leftmargini = 2.5em
\fi
\leftmargin\leftmargini
\leftmarginii  = 2.2em
\leftmarginiii = 1.87em
\leftmarginiv  = 1.7em
\if@twocolumn
  \leftmarginv  = .5em
  \leftmarginvi = .5em
\else
  \leftmarginv  = 1em
  \leftmarginvi = 1em
\fi
\def\@listi{\leftmargin\leftmargini
            \parsep 4\p@ \@plus2\p@ \@minus\p@
            \topsep 8\p@ \@plus2\p@ \@minus4\p@
            \itemsep4\p@ \@plus2\p@ \@minus\p@}
\let\@listI\@listi
\@listi
\def\@listii {\leftmargin\leftmarginii
              \labelwidth\leftmarginii
              \advance\labelwidth-\labelsep
              \topsep    4\p@ \@plus2\p@ \@minus\p@
              \parsep    2\p@ \@plus\p@  \@minus\p@
              \itemsep   \parsep}
\def\@listiii{\leftmargin\leftmarginiii
              \labelwidth\leftmarginiii
              \advance\labelwidth-\labelsep
              \topsep    2\p@ \@plus\p@\@minus\p@
              \parsep    \z@
              \partopsep \p@ \@plus\z@ \@minus\p@
              \itemsep   \topsep}
\def\@listiv {\leftmargin\leftmarginiv
              \labelwidth\leftmarginiv
              \advance\labelwidth-\labelsep}
\def\@listv  {\leftmargin\leftmarginv
              \labelwidth\leftmarginv
              \advance\labelwidth-\labelsep}
\def\@listvi {\leftmargin\leftmarginvi
              \labelwidth\leftmarginvi
              \advance\labelwidth-\labelsep}
\setlength  \labelwidth{\leftmargini}
\addtolength\labelwidth{-\labelsep}
\@lowpenalty=51
\@medpenalty=151
\@highpenalty=301
\@beginparpenalty=-\@lowpenalty
\@endparpenalty=-\@lowpenalty
\@itempenalty=-\@lowpenalty
%
%%% page styles
\def\ps@empty{\let\@mkboth\@gobbletwo
   \let\@oddhead\@empty \let\@evenhead\@empty
   \let\@oddfoot\@empty \let\@evenfoot\@empty}
\def\ps@plain{\ps@empty
   \def\@oddfoot{\normalfont\scriptsize \hfil\thepage\hfil}%
   \let\@evenfoot\@oddfoot}
\def\ps@headings{%
   \let\@oddfoot\@empty \let\@evenfoot\@empty
   \def\@evenhead{%
      \normalfont
      \footnotesize
      \rlap{\thepage}\hfil
      \let\thanks\thanks@warning
      \@setup@for@sc
      \leftmark{}{}\hfil}%
   \def\@oddhead{%
      \normalfont\footnotesize
      \let\thanks\thanks@warning
      \hfil \textit{\rightmark{}{}}\hfil
      \llap{\thepage}}%
   \let\@mkboth\markboth}
\def\leftmark{\expandafter\@firstoftwo\topmark{}{}}
\def\rightmark{\expandafter\@secondoftwo\botmark{}{}}
\def\ps@firstpage{%
   \let\@oddfoot\@empty
   \let\@evenfoot\@empty
   \def\@oddhead{\@article@info\hfil}%
   \let\@evenhead\@oddhead}
\def\@article@info{%
   \smash{%
     \raise3mm\hbox{% v1.3: added
     \parbox[t]{70mm}{\fontsize{8pt}{9pt}\selectfont
      \if@publish
         \textcopyright\@Year\ The Mathematical Society of Japan\\
         J. Math.\ Soc.\ Japan\\
         \ifx\@VolNoYear\@empty
            Vol.\,\@Vol, No.\,\@No\ (\@Year)\ %
         \else
            \@VolNoYear\ %
         \fi
         \def\@pageinfo{pp.\,??--??}%
         \@tempswafalse
         \ifx\@firstpage\@empty\else \ifx\@lastpage\@empty\else
               \@tempswatrue
         \fi\fi
         \if@tempswa
            \@tempcnta\@firstpage\relax
            \@tempcntb\@lastpage\relax
            \ifnum\@tempcntb>\@tempcnta
               \edef\@pageinfo{pp.\noexpand\,\@firstpage--\@lastpage}%
            \else
               \edef\@pageinfo{p.\noexpand\,\@firstpage}%
            \fi
         \else
            \expandafter\ifx\csname r@firstpage\endcsname\relax\else
               \expandafter\ifx\csname r@lastpage\endcsname\relax\else
                  \edef\@tempa{\expandafter\expandafter\expandafter
                     \@secondoftwo\csname r@firstpage\endcsname\@empty\@empty}%
                  \edef\@tempb{\expandafter\expandafter\expandafter
                     \@secondoftwo\csname r@lastpage\endcsname\@empty\@empty}%
                  \ifx\@tempa\@empty\else
                     \ifx\@tempb\@empty\else
                        \@tempcnta\@tempa\relax
                        \@tempcntb\@tempb\relax
                        \ifnum\@tempcntb>\@tempcnta
                           \edef\@pageinfo{pp.\noexpand\,\@tempa--\@tempb}%
                        \else
                           \edef\@pageinfo{p.\noexpand\,\@tempa}%
                        \fi
                     \fi
                  \fi
               \fi
            \fi
         \fi
         \@pageinfo\\
         \textcolor{Blue}{doi: 10.2969/jmsj/\@DOI}
      \else
         Submitted to\\
         \textit{Journal of the Mathematical Society of Japan}%
      \fi}}}}
\if@publish
\AtBeginDocument{%
   \@ifpackageloaded{color}\relax{%
      \@ifpackageloaded{xcolor}\relax
         {\expandafter\RequirePackage\expandafter[\defaultdriver,usenames]{color}}}%
   }
\fi
\def\defaultdriver{dvips}
\let\sectionmark\@gobble
\let\subsectionmark\@gobble
\let\subsubsectionmark\@gobble
\let\paragraphmark\@gobble
\@ifclasswith{jmsj}{nomath}\relax{\RequirePackage{amsmath}}%
\@ifclasswith{jmsj}{nothm}\relax{\RequirePackage{amsthm}}%
\@ifundefined{numberwithin}%
  {\newcommand{\numberwithin}[3][\arabic]{%
      \@ifundefined{c@#2}%
         {\@nocounterr{#2}}%
         {\@ifundefined{c@#3}%
             {\@nocnterr{#3}}%
             {\@addtoreset{#2}{#3}%
              \expandafter\xdef\csname the#2\endcsname{%
                \expandafter\noexpand\csname the#3\endcsname .\noexpand#1{#2}}}}}%
   \csname newtoks\endcsname\@emptytoks}%
  {}
\@ifclasswith{jmsj}{noamsfonts}\relax
  {\begingroup
   \fontencoding{U}\fontfamily{msa}\try@load@fontshape\endgroup
   \global\expandafter\let\csname U+msa\endcsname\relax
   \@ifundefined{U/msa/m/n}%
      {\ClassError{jmsj}%
         {Package `amsfonts' not installed, or version too old?\MessageBreak
          Unable to get font info for the `msam' fonts in the expected form}%
         {The amsfonts package will not be loaded, to avoid probable\MessageBreak
          incompatibility problems. You can (a) use the `noamsfonts'
          documentclass\MessageBreak
          option next time, or (b) check that the amsfonts package is
          installed\MessageBreak
          correctly, and is not too old to be compatible.}}%
      {\RequirePackage{amsfonts}}}
\let\@original@cleardoublepage\cleardoublepage
\AtBeginDocument{%
  \ifx\cleardoublepage\@original@cleardoublepage
    \def\cleardoublepage{\clearpage{\pagestyle{empty}\@original@cleardoublepage}}%
  \fi}
\newcommand*{\uppercasenonmath}[1]{%
   \toks@\@emptytoks
   \expandafter\@skipmath\expandafter\@empty#1$$%
   \edef#1{{\noexpand\protect\noexpand\@upprep\the\toks@}}}
\newcommand{\@upprep}{%
   \spaceskip1.3\fontdimen2\font plus1.3\fontdimen3\font
   \upchars@}
\newcommand{\upchars@}{%
   \def\ss{SS}\def\i{I}\def\j{J}\def\ae{\AE}\def\oe{\OE}%
   \def\o{\O}\def\aa{\AA}\def\l{\L}\def\Mc{M{\scshape c}}}
\providecommand{\Mc}{Mc}
\long\def\@skipmath#1$#2${%
  \@xskipmath#1\(\)%
  \@ifnotempty{#2}{\toks@\expandafter{\the\toks@$#2$}\@skipmath\@empty}}%
\long\def\@xskipmath#1\(#2\){%
   \uppercase{%
      \toks@
      \expandafter\expandafter\expandafter{%
      \expandafter\the\expandafter\toks@#1}}%
   \@ifnotempty{#2}{\toks@\expandafter{\the\toks@\(#2\)}\@xskipmath\@empty}}%
\def\altucnm#1{\MakeTextUppercase{\toks@{#1}}\edef#1{\the\toks@}}
\AtBeginDocument{%
   \@ifundefined{MakeTextUppercase}{}{\let\uppercasenonmath\altucnm}}
\@ifundefined{MakeUppercase}{\let\MakeUppercase\uppercase}{}%
%
\newcommand{\today}{%
  \relax\ifcase\month\or
  January\or February\or March\or April\or May\or June\or
  July\or August\or September\or October\or November\or December\fi
  \space\number\day, \number\year}
\DeclareOldFontCommand{\rm}{\normalfont\rmfamily}{\mathrm}
\DeclareOldFontCommand{\sf}{\normalfont\sffamily}{\mathsf}
\DeclareOldFontCommand{\tt}{\normalfont\ttfamily}{\mathtt}
\DeclareOldFontCommand{\bf}{\normalfont\bfseries}{\mathbf}
\DeclareOldFontCommand{\it}{\normalfont\itshape}{\mathit}
\DeclareOldFontCommand{\sl}{\normalfont\slshape}{\@nomath\sl}
\DeclareOldFontCommand{\sc}{\normalfont\scshape}{\@nomath\sc}
\DeclareRobustCommand*\cal{\@fontswitch\relax\mathcal}
\DeclareRobustCommand*\mit{\@fontswitch\relax\mathnormal}
\def\title{\@dblarg\@get@title}
\def\@get@title[#1]#2{%
   \gdef\@title@for@head{#1}%
   \gdef\@title{#2}}
\def\@title@for@head{???}
\def\subtitle#1{\gdef\@subtitle{#1}}
\global\let\@subtitle\@empty
\newcount\@authorid \global\@authorid\z@
\renewcommand*{\author}[2][]{%
   \global\advance\@authorid\@ne
   \global\@namedef{@author@for@head@\the\@authorid}{#1}%
   \global\@namedef{@author@\the\@authorid}{#2}}
%
%%% for compatibility with amsart
\newcommand*{\contrib}[2][]{}
\newcommand*{\address}[2][]{\global\@namedef{@address@\the\@authorid}{#2}}
\newcommand*{\curraddr}[2][]{\global\@namedef{@curr@address@\the\@authorid}{#2}}
\newcommand*{\email}[2][]{\global\@namedef{@email@\the\@authorid}{#2}}
\newcommand*{\urladdr}[2][]{\global\@namedef{@urladdr@\the\@authorid}{#2}}
\long\def\thanks@warning@#1{%
   \ClassError{jmsj}{%
      \protect\thanks\space should be given separately, not inside author name.}%
      \@ehb
   \global\let\thanks@warning\@gobble}
\global\let\thanks@warning\thanks@warning@
\@ifundefined{ISSN}{\def\ISSN{0000-0000}}{}
\newcommand*\PII[1]{\def\@PII{#1}}
\PII{S \ISSN(XX)0000-0}
\renewcommand*{\thanks}[1]{\global\@namedef{@thanks@\the\@authorid}{#1}}
\let\@date\@empty
\def\dedicatory#1{\def\@dedicatory{#1}}
\let\@dedicatory\@empty
\def\keywords#1{\def\@keywords{#1}}
\let\keyword\keywords
\let\@keywords\@empty
\def\funding#1{\def\@funding{#1}}
\let\funding\funding
\let\@funding\@empty
\newcommand*\subjclass[2][1991]{%
%%	   \gdef\@subjclass{\textup{#1} \textit{Mathematics Subject Classification}.\quad #2.}
   \gdef\@subjclass{\textup{#1} \textit{Mathematics Subject Classification.}\hskip6pt #2.}% v1.3: changed
}
\let\@subjclass\@empty
\def\commby#1{\def\@commby{(Communicated by #1)}}
\let\@commby\@empty
\def\translator#1{\g@addto@macro\@translators{\@elt{#1}}}
\let\@translators\@empty
\def\@settranslators{%
   \par
   \begingroup
   \addvspace{6\p@\@plus9\p@}%
   \def\@elt##1{\advance\count@\@ne}%
   \count@\z@
   \@translators
   \def\@translator@separator@a@before@break{,}%
   \def\@translator@separator@a@after@break{}%
   \edef\@translator@separator@b@before@break{\ifnum\count@>\tw@,\fi}%
   \def\@translator@separator@b@after@break{and }%
   \normalfont\normalsize\raggedleft
   \setbox\z@\hbox{Translated by }%
   \@tempcnta\z@
   \if@twocolumn\@tempdima.99\columnwidth
   \else        \@tempdima.8\columnwidth
   \fi
   \def\@elt##1{%
      \advance\@tempcnta\@ne
      \def\@curr@name{##1}%
      \@convert@to@uppercase\@curr@name
      \ifnum\@tempcnta>\@ne
         \ifnum\@tempcnta<\count@
            \let\@translator@separator@bb\@translator@separator@a@before@break
            \let\@translator@separator@ab\@translator@separator@a@after@break
         \else
            \let\@translator@separator@bb\@translator@separator@b@before@break
            \let\@translator@separator@ab\@translator@separator@b@after@break
         \fi
      \else
         \let\@translator@separator@bb\@gobble
         \let\@translator@separator@ab\@empty
      \fi
      \setbox\tw@\hbox{%
         \unhcopy\z@
         \@translator@separator@bb\space \@translator@separator@ab
         \@curr@name}%
      \ifnum\@tempcnta>\@ne
         \ifdim\wd\tw@>\@tempdima
            \unhbox\z@\@translator@separator@bb\relax\par
            \setbox\z@\hbox{\@translator@separator@ab \@curr@name}%
         \else
            \setbox\z@\box\tw@
         \fi
      \else
         \setbox\z@\box\tw@
      \fi}%
   \@translators
   \unhbox\z@\par
   \endgroup}
%
%%% \maketitle
\def\@maketitle{%
   \null\label{firstpage}%
%%	   \vspace{4mm}%
   \vspace{1.1mm}% v1.3: changed
   \begingroup\centering
   {\large\bfseries\boldmath \@title\par}%
   \ifx\@subtitle\@empty\else
      {\small\normalfont \@subtitle\par}%
   \fi
   \vspace{6mm}%
   \fontsize{10}{12}\selectfont
   \@format@author
   \par
   \ifx\@dedicatory\@empty\else
      \vspace{4mm}%
      \@dedicatory\par
   \fi
%%	   \addvspace{5mm}%
   \addvspace{5.8mm}% v1.3: changed
   \fontsize{8pt}{9pt}\selectfont
   \ifx\@recdate\@empty
      \ifx\@date\@empty\else \@date\par \fi
   \else
      (Received \@recdate)\par
      \ifx\@revdate\@empty\else (Revised \@revdate)\par \fi
   \fi
   \ifvoid\abstractbox\else
%%	      \addvspace{6mm}%
      \addvspace{5.8mm}% v1.3: changed
      \unvbox\abstractbox
   \fi
   \endgroup
   \@put@thanks
   \if@titlepage
      \thispagestyle{empty}%
      \newpage
   \else
      \thispagestyle{firstpage}%
      \addvspace{6mm}%
   \fi
   \global\let\maketitle\relax
   \gdef\@abstract@set@hsize{%
      \if@twocolumn\else \leftskip=17mm \rightskip=17mm\relax \fi}}
\def\@@maketitle{%
   \if@twocolumn \twocolumn[\vskip\topskip \@maketitle]\relax
   \else         \@maketitle
   \fi}
\global\let\maketitle\@@maketitle
\def\recdate#1#2#3{\gdef\@recdate{\Month{#2}\ #3,\ #1}}
\def\revdate#1#2#3{\gdef\@revdate{\Month{#2}\ #3,\ #1}}
\def\Month#1{%
   \begingroup
   \afterassignment\remove@to@nnil
   \count@=0#1\relax\@nnil
   \ifnum\count@=\z@
      #1%
   \else
      \ifcase#1\relax ???\or Jan.\or Feb.\or Mar.\or Apr.\or May\or June\or
      July\or Aug.\or Sep.\or Oct.\or Nov.\or Dec.\else ???\fi
   \fi
   \endgroup}
\let\@recdate\@empty
\let\@revdate\@empty
\def\date#1{\gdef\@date{#1}}
\let\@date\@empty
\def\@format@author{%
   \ifnum\@authorid<\@ne
      \ClassWarning{jmsj}{No author is given}%
   \else
      \@format@author@
   \fi}
\def\@format@author@{%
   \begingroup
   \def\thefootnote{\fnsymbol{footnote}}%
   \global\let\@@authors@for@head\@empty
   \@tempcnta\z@
   By\ %
   \@whilenum\@tempcnta<\@authorid\do{%
      \advance\@tempcnta\@ne
      \ifnum\@tempcnta>\@ne
         \unskip
         \ifnum\@tempcnta<\@authorid
            ,\ %
            \g@addto@macro\@@authors@for@head{,\ }%
         \else
            \ and\ %
            \g@addto@macro\@@authors@for@head{\ and\ }%
         \fi
      \fi
      \@check@and@normalize@author}%
   \endgroup}
\newif\if@sc@is@used
\newif\if@sc@is@not@enclosed
\newif\if@failed@to@split@author
\def\@check@and@normalize@author{%
   \@failed@to@split@authorfalse
   \expandafter\let\expandafter\@org@name\csname @author@\the\@tempcnta\endcsname
   \@check@math@cmds@in@author\@org@name
   \def\@tempz##1\textsc##2##3\@nil{%
      \def\@temp@givenname{##1}%
      \def\@temp@surname{##2}}%
   \expandafter\@tempz\@org@name\textsc{}\@nil
   \ifx\@temp@surname\@empty
      \global\@sc@is@usedfalse
      \global\@sc@is@not@enclosedfalse
      \setbox\z@\hbox{%
         \def\sc{\global\@sc@is@usedtrue \let\sc\relax}%
         \@org@name
         \ifx\sc\relax \global\@sc@is@not@enclosedtrue \fi}%
      \if@sc@is@used
         \if@sc@is@not@enclosed
            \def\@tempz##1\sc##2\sc##3\@nil{%
               \def\@temp@givenname{##1}%
               \def\@temp@surname{##2}}%
            \expandafter\@tempz\@org@name\sc\sc\@nil
         \else
            \@split@by@space\@org@name
            \@check@enclosed@sc
            \ifx\@temp@givenname\@empty\else
               \@csc@t\@temp@givenname\@temp@givenname\space
            \fi
            \ifx\@temp@surname\@empty
               \@failed@to@split@authortrue
               \ClassWarning{jmsj}{%
                  I failed to split author name into\MessageBreak
                  given-name-part and surname-part.\MessageBreak
                  Please apply \string\textsc\space to surname}%
            \fi
         \fi
      \fi
   \else
      \def\@tempz##1\textsc##2##3\@nil{%
         \def\@temp@head{##1}%
         \def\@temp@middle{##2}%
         \def\@temp@tail{##3}}%
      \expandafter\@tempz\@org@name\@nil
      \let\@temp@givenname\@temp@head
      \let\@temp@surname\@temp@middle \@remove@last@spaces\@temp@surname
      \def\@tempzz##1\textsc##2##3\@nil{%
         \def\@temp@head{##1}%
         \def\@temp@arg{##2}}%
      \ifx\@temp@tail\space \let\@temp@tail\@empty \fi
      \loop\ifx\@temp@tail\@empty\else
         \expandafter\@tempzz\@temp@tail\textsc{}\@nil
         \ifx\@temp@arg\@empty
            \@csc@t\@temp@surname\@temp@surname\@temp@tail
            \let\@temp@tail\@empty
         \else
            \expandafter\@tempz\@temp@tail\@nil
            \@remove@top@spaces\@temp@head
            \@remove@last@spaces\@temp@head
            \@remove@top@spaces\@temp@middle
            \@remove@last@spaces\@temp@middle
            \ifx\@temp@head\@empty\else
               \@csc@t\@temp@head\space\@temp@head
               \@csc@t\@temp@surname\@temp@surname\@temp@head
            \fi
            \@csc@t\@temp@middle\space\@temp@middle
            \@csc@t\@temp@surname\@temp@surname\@temp@middle
            \ifx\@temp@tail\space \let\@temp@tail\@empty \fi
         \fi
      \repeat
%%% Note: If \textsc is applied, then it might be better to use the argument
%%%       of \author intact. (In case of given surname is ``McMillan''
%%%       or so, we should not convert it into lowercase mechanically.)
%%%      \let\@tempname\@temp@surname
%%%      \@convert@to@uppercase\@tempname
%%%      \ifx\@temp@surname\@tempname
%%%         \@convert@to@lowercase@without@initial\@temp@surname
%%%      \fi
   \fi
   \ifx\@temp@surname\@empty
      \if@failed@to@split@author
         \let\@temp@surname\@org@name
         \let\@temp@givenname\@empty
      \else
         \@split@by@space\@org@name
         \let\@saved@elt\@elt
         \count@\z@
         \def\@elt##1{%
            \advance\count@\@ne
            \expandafter\def\csname @temp@name@\the\count@\endcsname{##1}}%
         \@split@by@space@result
         \edef\@number@of@fragments{\the\count@}%
         \ifnum\@number@of@fragments=\tw@
            \expandafter\let\expandafter\@temp@givenname\csname @temp@name@1\endcsname
            \let\@tempnamea\@temp@givenname
            \@convert@to@uppercase\@tempnamea
            \ifx\@tempnamea\@temp@givenname
               \@convert@to@lowercase@without@initial\@temp@givenname
            \fi
            \expandafter\let\expandafter\@temp@surname\csname @temp@name@2\endcsname
         \else
            \ifnum\@number@of@fragments=\thr@@
               \expandafter\let\expandafter\@tempa\csname @temp@name@2\endcsname
               \expandafter\lowercase\expandafter{%
                  \expandafter\def\expandafter\@tempb\expandafter{\@tempa}}%
               \@tempswafalse
               \@tfor\@tempc:={von}{van}{de}{le}\do{%
                  \ifx\@tempb\@tempc \@tempswatrue \fi}%
               \if@tempswa
                  \expandafter\let\expandafter\@temp@givenname\csname @temp@name@1\endcsname
                  \expandafter\let\expandafter\@temp@surname\csname @temp@name@3\endcsname
                  \@csc@t\@tempa\@tempa\space
                  \@csc@t\@temp@surname\@tempa\@temp@surname
               \fi
            \fi
            \ifx\@temp@surname\@empty
               \let\@tempnamea\@empty
               \let\@tempnameb\@empty
               \def\@elt##1{%
                  \def\@tempa{##1}%
                  \let\@tempb\@tempa
                  \@convert@to@uppercase\@tempb
                  \ifx\@tempa\@tempb
                     \let\@tempnameb\@tempa
                     \def\@elt####1{%
                        \def\@tempa{ ####1}%
                        \@csc@t\@tempnameb\@tempnameb\@tempa}%
                  \else
                     \ifx\@tempnamea\@empty
                        \let\@tempnamea\@tempa
                     \else
                        \def\@tempa{ ##1}%
                        \@csc@t\@tempnamea\@tempnamea\@tempa
                     \fi
                  \fi}%
               \@split@by@space@result
               \ifx\@tempnamea\@empty\else
                  \ifx\@tempnameb\@empty\else
                     \let\@temp@givenname\@tempnamea
                     \let\@temp@surname\@tempnameb
                  \fi
               \fi
               \ifx\@temp@surname\@empty
                  \count@\@number@of@fragments\relax
                  \expandafter\let\expandafter\@temp@surname
                     \csname @temp@name@\the\count@\endcsname
                  \advance\count@\m@ne
                  \begingroup
                  \@tempcnta\z@
                  \@whilenum\@tempcnta<\count@\do{%
                     \advance\@tempcnta\@ne
                     \expandafter\let\expandafter\@tempa
                        \csname @temp@name@\the\@tempcnta\endcsname
                     \ifnum\@tempcnta=\@ne
                        \let\@temp@givenname\@tempa
                     \else
                        \@csc@t\@tempa\space\@tempa
                        \@csc@t\@temp@givenname\@temp@givenname\@tempa
                     \fi}%
                  \expandafter\endgroup
                  \expandafter\def\expandafter\@temp@givenname\expandafter{\@temp@givenname}%
               \fi
            \fi
         \fi
         \@convert@to@lowercase@without@initial\@temp@surname
         \let\@elt\@saved@elt
      \fi
   \fi
   \ifx\@temp@givenname\@empty\else
      \@remove@last@spaces\@temp@givenname
      \@csc@t\@temp@givenname\@temp@givenname\space
   \fi
   \@remove@top@spaces\@temp@givenname
   \@remove@top@spaces\@temp@surname
   \ifx\@temp@givenname\@empty\else
      \@check@By\@temp@givenname
   \fi
   \expandafter\let\expandafter\@temp@author@for@head
      \csname @author@for@head@\the\@tempcnta\endcsname
   \ifx\@temp@author@for@head\@empty
      \let\@temp@author@for@head\@temp@givenname
      \@initialize\@temp@author@for@head
      \@csc@t\@temp@author@for@head\@temp@author@for@head\space
      \expandafter\def\expandafter\@tempz\expandafter{%
         \expandafter\textsc\expandafter{\@temp@surname}}%
      \@csc@t\@temp@author@for@head\@temp@author@for@head\@tempz
   \fi
   \expandafter\g@addto@macro\expandafter\@@authors@for@head\expandafter{%
      \@temp@author@for@head}%
   \if@failed@to@split@author
      \@temp@surname
      \expandafter\gdef
         \csname @normalized@authorname@\the\@tempcnta\expandafter\endcsname
         \expandafter{\@temp@surname}%
   \else
      \toks@\expandafter{\@temp@givenname}%
      \@temptokena\expandafter{\@temp@surname}%
      \expandafter\xdef
         \csname @normalized@authorname@\the\@tempcnta\endcsname
         {\the\toks@ \noexpand\textsc{\noexpand\@setup@for@sc \the\@temptokena}}%
      \@nameuse{@normalized@authorname@\the\@tempcnta}%
   \fi}
\def\@setup@for@sc{%
   \expandafter\let\csname \string\OT1\string\.-i\endcsname\relax
   \expandafter\let\csname \string\OT1\string\.-\string\i\endcsname\relax
   \expandafter\let\csname \string\T1\string\.-i\endcsname\relax
   \expandafter\let\csname \string\T1\string\.-\string\i\endcsname\relax}
\def\@csc@t#1#2#3{%
   \expandafter\expandafter\expandafter\def
   \expandafter\expandafter\expandafter#1%
   \expandafter\expandafter\expandafter{%
      \expandafter#2#3}}
\def\@remove@top@spaces#1{%
   \begingroup
   \def\@remove@top@spaces@@@@##1\@nil{%
      \expandafter\def\expandafter\@tempz{%
         \expandafter\def\expandafter#1\expandafter{##1}}}%
   \expandafter\@remove@top@spaces@#1\@nil
   \expandafter\endgroup\@tempz}
\def\@remove@top@spaces@{\futurelet\@tempchar\@remove@top@spaces@@}%
\def\@remove@top@spaces@@{%
   \ifx\@tempchar\@sptoken \expandafter\@remove@top@spaces@@@
   \else                   \expandafter\@remove@top@spaces@@@@\expandafter\@empty
   \fi}%
\begingroup
\def\:{\def\@remove@top@spaces@@@}%
\expandafter\endgroup\: {\@remove@top@spaces@}%
\def\@remove@last@spaces#1{%
   \begingroup
   \def\@tempz##1 \@nil##2\@nnil{\def\@tempa{##2}}%
   \expandafter\expandafter\expandafter\@tempz
      \expandafter#1\expandafter\@nil\space\@nil\@nnil
   \ifx\@tempa\@empty
      \let\@tempa\@empty
   \else
      \def\@tempz##1 \@nil##2\@nnil{%
         \expandafter\def\expandafter\@tempa\expandafter{%
            \expandafter\def\expandafter#1\expandafter{##1}}}%
      \expandafter\@tempz\expandafter\@empty#1\@nil\@nnil
   \fi
   \expandafter\endgroup\@tempa}
\def\@split@by@space#1{%
   \begingroup
   \let\@templista\@empty
   \expandafter\@split@by@space@\expandafter{\space}#1\@templista
   \let\@templistb\@empty
   \def\@elt##1{%
      \def\@tempa{##1}%
      \@split@by@space@~\@tempa\@templistb}%
   \@templista
   \expandafter\endgroup
   \expandafter\def\expandafter\@split@by@space@result\expandafter{\@templistb}}
\def\@split@by@space@#1#2#3{%
   \count@\z@
   \def\@tempz##1#1{%
      \expandafter\def\expandafter\@tempa\expandafter{##1}%
      \ifx\@tempa\@nnil\else
         \advance\count@\@ne
         \expandafter\def\expandafter\@tempa\expandafter{%
            \expandafter\@elt\expandafter{##1}}%
         \@csc@t#3#3\@tempa
         \expandafter\@tempz\expandafter\@empty
      \fi}%
   \expandafter\@tempz\expandafter\@empty#2#1\@nil#1}
\newif\if@check@math@cmds@mathmode
\newif\if@check@math@cmds@complicated@math
\def\@check@math@cmds@in@author#1{%
   \begingroup
   \count@\z@
   \@check@math@cmds@mathmodefalse
   \expandafter\@check@math@cmds@#1\@nnil
   \expandafter\endgroup
   \expandafter\def\expandafter#1\expandafter{\@tempstr}}
\def\@check@math@cmds@{%
   \let\@tempstr\@empty
   \let\@temp@text\@empty
   \@check@math@cmds@loop}
\def\@check@math@cmds@loop{%
   \futurelet\@check@math@cmds@temp\@check@math@cmds@loop@}
\def\@check@math@cmds@loop@{%
   \def\@check@math@cmds@next{\@check@math@cmds@normal}%
   \ifx     \@check@math@cmds@temp\@nnil
      \def\@check@math@cmds@next{\@check@math@cmds@finish}%
      \if@check@math@cmds@mathmode
         \ifnum\count@=\z@
            \def\@check@math@cmds@next{\@check@math@cmds@loop$}%
         \fi
      \fi
   \else\ifx\@check@math@cmds@temp\bgroup
      \def\@check@math@cmds@next{\@check@math@cmds@bgroup}%
   \else\ifx\@check@math@cmds@temp\@sptoken
      \def\@check@math@cmds@next{\@check@math@cmds@space}%
   \fi\fi\fi
   \@check@math@cmds@next}
\def\@check@math@cmds@finish#1\@nnil{}
\def\@check@math@cmds@bgroup#1{%
   \begingroup
   \advance\count@\@ne
   \@check@math@cmds@#1\@nnil
   \toks@\expandafter{\@tempstr}%
   \@temptokena\expandafter{\@temp@text}%
   \edef\@tempa{%
      \if@check@math@cmds@complicated@math
         \noexpand\@check@math@cmds@complicated@mathtrue
      \fi
      \def\noexpand\@tempa{{\the\toks@}}%
      \def\noexpand\@tempb{{\the\@temptokena}}}%
   \expandafter\endgroup\@tempa
   \@csc@t\@tempstr\@tempstr\@tempa
   \if@check@math@cmds@mathmode
      \@csc@t\@temp@text\@temp@text\@tempb
   \fi
   \@check@math@cmds@loop}
\begingroup
\def\:{\def\@check@math@cmds@space}%
\expandafter\endgroup\: {%
   \@csc@t\@tempstr\@tempstr\space
   \@check@math@cmds@loop}
\def\@check@math@cmds@normal#1{%
   \def\@tempa{#1}%
   \def\@tempb{$}%
   \def\@check@math@cmds@next{%
      \@csc@t\@tempstr\@tempstr\@tempa
      \@check@math@cmds@loop}%
   \ifx\@tempa\@tempb
      \if@check@math@cmds@mathmode
         \@check@math@cmds@mathmodefalse
         \if@check@math@cmds@complicated@math
            \toks@\expandafter{\@saved@tempstr}%
            \@temptokena\expandafter{\@tempstr}%
            \edef\@tempstr{\the\toks@$\the\@temptokena$}%
         \else
            \@csc@t\@tempstr\@saved@tempstr\@temp@text
         \fi
      \else
         \@check@math@cmds@mathmodetrue
         \@check@math@cmds@complicated@mathfalse
         \let\@saved@tempstr\@tempstr
         \let\@tempstr\@empty
         \let\@temp@text\@empty
      \fi
      \def\@check@math@cmds@next{\@check@math@cmds@loop}%
   \else
      \if@check@math@cmds@mathmode
         \def\@check@math@cmds@next{\@check@math@cmds@in@math}%
      \fi
   \fi
   \@check@math@cmds@next}
\def\@check@math@cmds@in@math{%
   \def\@tempb{_}%
   \def\@tempc{^}%
   \ifx\@tempa\@tempb \@check@math@cmds@complicated@mathtrue \fi
   \ifx\@tempa\@tempc \@check@math@cmds@complicated@mathtrue \fi
   \def\@check@math@cmds@next{\@check@math@cmds@loop}%
   \def\@tempz##1##2{%
      \def\@tempb{##1}%
      \def\@tempx{##2}%
      \ifx\@tempb\@nnil
         \expandafter\remove@to@nnil
      \else
         \ifx\@tempa\@tempb
            \def\@check@math@cmds@next{\@check@math@cmds@accent}%
            \expandafter\expandafter\expandafter\@secondoftwo
         \else
            \expandafter\expandafter\expandafter\@firstoftwo
         \fi
      \fi
      \@tempz\remove@to@nnil}%
   \@tempz\acute\'\grave\`\dot\.\ddot\"\hat\^\check\v\breve\u
          \tilde\~\bar\=\overline\=\mathring\r\underline\b
          \@nil\@nil\@nnil
   \ifx\@tempx\@nnil
      \def\@tempz##1##2{%
         \def\@tempb{##1}%
         \ifx\@tempb\@nnil
            \expandafter\remove@to@nnil
         \else
            \ifx\@tempa\@tempb
               \def\@tempx{##2}%
               \expandafter\expandafter\expandafter\@secondoftwo
            \else
               \expandafter\expandafter\expandafter\@firstoftwo
            \fi
         \fi
         \@tempz\remove@to@nnil}%
      \@tempz~{ }\ { }\rm{}\mathrm{}\imath\i\jmath\j\@nil\@nil\@nnil
   \fi
   \ifx\@tempx\@nnil
      \@tfor\@tempb:=\mbox\hbox\text\textrm\textnormal\do{%
         \ifx\@tempa\@tempb
            \def\@check@math@cmds@next{\@check@math@cmds@textcmd}%
            \let\@tempx\@empty
            \@break@tfor
         \fi}%
   \fi
   \ifx\@tempx\@nnil
      \expandafter\if\expandafter\noexpand\@tempa\relax
         \@check@math@cmds@complicated@mathtrue
      \fi
      \let\@tempx\@tempa
   \fi
   \@csc@t\@tempstr\@tempstr\@tempa
   \@csc@t\@temp@text\@temp@text\@tempx
   \@check@math@cmds@next}
\def\@check@math@cmds@accent#1{%
   \def\@tempa{#1}%
   \def\@tempb{\@nnil}%
   \ifx\@tempa\@tempb \expandafter\@secondoftwo
   \else              \expandafter\@firstoftwo
   \fi
   {\@check@math@cmds@accent@{#1}}%
   {\@check@math@cmds@accent@{}\@nnil}}
\def\@check@math@cmds@accent@#1{%
   \begingroup
   \advance\count@\@ne
   \@check@math@cmds@mathmodetrue
   \@check@math@cmds@complicated@mathfalse
   \@check@math@cmds@#1\@nnil
   \if@check@math@cmds@complicated@math\else
      \expandafter\@check@math@cmds@accent@@\@temp@text\@nnil
      \def\@tempz##1##2\@nnil{\def\@tempa{##2}}%
      \expandafter\@tempz\@temp@text\@nil\@nnil
      \ifx\@temp@text\@empty\else
         \ifx\@tempa\@nnil\else
            \@check@math@cmds@complicated@mathtrue
         \fi
      \fi
   \fi
   \toks@\expandafter{\@tempstr}%
   \@temptokena\expandafter{\@temp@text}%
   \edef\@tempa{%
      \if@check@math@cmds@complicated@math
         \noexpand\@check@math@cmds@complicated@mathtrue
      \fi
      \def\noexpand\@tempa{{\the\toks@}}%
      \def\noexpand\@tempb{{\the\@temptokena}}}%
   \expandafter\endgroup\@tempa
   \@csc@t\@tempstr\@tempstr\@tempa
   \@csc@t\@temp@text\@temp@text\@tempb
   \@check@math@cmds@loop}
\def\@check@math@cmds@accent@@{\futurelet\@tempa\@check@math@cmds@accent@@@}
\def\@check@math@cmds@accent@@@{%
   \ifx\@tempa\bgroup
      \def\@tempz##1##2\@nnil{%
         \def\@tempa{##2}%
         \ifx\@tempa\@empty
            \def\@temp@text{##1}%
            \expandafter\@firstofone
         \else
            \expandafter\@gobble
         \fi
         {\@check@math@cmds@accent@@##1\@nnil}}%
   \else
      \def\@tempz##1\@nnil{\def\@temp@text{##1}}%
   \fi
   \@tempz}
\def\@check@math@cmds@textcmd#1{%
   \def\@tempa{#1}%
   \def\@tempb{\@nnil}%
   \ifx\@tempa\@tempb \expandafter\@secondoftwo
   \else              \expandafter\@firstoftwo
   \fi
   {\@check@math@cmds@textcmd@{#1}}%
   {\@check@math@cmds@textcmd@{}\@nnil}}
\def\@check@math@cmds@textcmd@#1{%
   \begingroup
   \advance\count@\@ne
   \@check@math@cmds@mathmodefalse
   \@check@math@cmds@complicated@mathfalse
   \@check@math@cmds@#1\@nnil
   \toks@\expandafter{\@tempstr}%
   \def\@tempz##1$##2$##3\@nnil{\def\@tempa{##2}}%
   \expandafter\@tempz\@tempstr$\@nil$\@nnil
   \edef\@tempa{%
      \ifx\@tempa\@nnil\else
         \noexpand\@check@math@cmds@complicated@mathtrue
      \fi
      \def\noexpand\@tempa{{\the\toks@}}}%
   \expandafter\endgroup\@tempa
   \@csc@t\@tempstr\@tempstr\@tempa
   \@csc@t\@temp@text\@temp@text\@tempa
   \@check@math@cmds@loop}
\def\@check@enclosed@sc{%
   \let\@saved@elt\@elt
   \let\@temp@givenname\@empty
   \let\@temp@surname\@empty
   \def\@tempz##1\@nnil{%
      \def\@tempb{##1}%
      \ifx\@tempa\@tempb \expandafter\remove@to@nnil
      \else              \let\@tempa\@tempb  \expandafter\@tempz
      \fi
      ##1\@nnil}%
   \def\@tempzz##1\sc##2\@nil{\def\@tempb{##2}}%
   \def\@elt##1{%
      \def\@tempa{##1}%
      \@tempz##1\@nnil
      \expandafter\@tempzz\@tempa\sc\@nil
      \ifx\@tempb\@empty
         \@check@enclosed@sc@\@temp@givenname\@tempa
      \else
         \def\@tempzz####1\sc####2\@nil{\def\@tempb{####1####2}}%
         \expandafter\@tempzz\@tempa\@nil
         \let\@temp@surname\@tempb
         \def\@elt####1{%
            \def\@tempa{####1}%
            \@check@enclosed@sc@\@temp@surname\@tempa}%
      \fi}%
   \@split@by@space@result
   \let\@elt\@saved@elt}
\def\@check@enclosed@sc@#1#2{%
   \ifx#2\@empty\else
      \ifx#1\@empty
         \let#1#2%
      \else
         \@csc@t#2\space#2%
         \@csc@t#1#1#2%
      \fi
   \fi}
\def\@accentlist{\'\`\.\"\H\^\v\u\~\=\r\d\b\c\k\t}
\def\@convert@to@uppercase#1{%
   \begingroup
   \escapechar`\\%
   \def\@tempz##1{%
      \ifx##1\@nnil\else
         \def##1{\noexpand##1}%
         \expandafter\@tempz
      \fi}%
   \expandafter\@tempz\@accentlist\IeC\a\@tabacckludge\@nnil
   \def\@tempz##1##2{%
      \ifx##1\@nnil\else
         \def##1{\noexpand##2}%
         \expandafter\@tempz
      \fi}%
   \expandafter\@tempz\@uclclist\ij\IJ\@nnil\@nnil
   \def\@tempz##1{%
      \ifx##1\@nnil\else
         \ifcat\noexpand##1\noexpand~%
            \expandafter\def\csname\string~\string##1\endcsname{\noexpand##1}%
         \else
            \expandafter\def\csname\string~\string##1\endcsname{##1}%
         \fi
         \expandafter\@tempz
      \fi}%
   \@tempz'`."^~=Hvurdbckt\@nnil
   \let\protect\noexpand
   \def\@tempx##1##2{%
      \noexpand##1\expandafter\noexpand\csname\string~\string##2\endcsname}%
   \def\a{\@tempx\a}%
   \def\@tabacckludge{\@tempx\@tabacckludge}%
   \edef\@tempa{#1}%
   \def\@tempx##1##2{%
      \noexpand##1%
      \ifx##2\@undefined \expandafter\@gobbletwo\string##2%
      \else              ##2%
      \fi}%
   \expandafter\uppercase\expandafter{%
      \expandafter\edef\expandafter\@tempa\expandafter{\@tempa}}%
   \expandafter\endgroup
   \expandafter\def\expandafter#1\expandafter{\@tempa}}
\def\@convert@to@lowercase@without@initial#1{%
   \begingroup
   \@split@by@space#1%
   \@take@initial@letter@setup
   \def\@tempz##1##2{%
      \ifx##1\@nnil\else
         \def##2{\noexpand##1}%
         \expandafter\@tempz
      \fi}%
   \expandafter\@tempz\@uclclist\ij\IJ\@nnil\@nnil
   \let\@tempname\@empty
   \def\@elt##1{%
      \@take@initial@letter{##1}%
      \expandafter\lowercase\expandafter{%
         \expandafter\def\expandafter\@temp@tail\expandafter{\@temp@tail}}%
      \ifx\@tempname\@empty\else
         \@csc@t\@temp@initial\space\@temp@initial
      \fi
      \@csc@t\@tempa\@temp@initial\@temp@tail
      \@csc@t\@tempname\@tempname\@tempa}%
   \@split@by@space@result
   \expandafter\endgroup
   \expandafter\def\expandafter#1\expandafter{\@tempname}}
\def\@initialize#1{%
   \begingroup
   \@split@by@space#1%
   \@take@initial@letter@setup
   \def\@tempz##1##2{%
      \ifx##1\@nnil\else
         \def##1{\noexpand##1}%
         \def##2{\noexpand##2}%
         \expandafter\@tempz
      \fi}%
   \expandafter\@tempz\@uclclist\ij\IJ\@nnil\@nnil
   \let\@tempname\@empty
   \def\@elt##1{%
      \def\@tempa{##1}%
      \ifx\@tempa\@empty\else
         \@take@initial@letter{##1}%
         \ifx\@tempname\@empty\else
            \def\@tempa{~}%
            \@csc@t\@temp@initial\@tempa\@temp@initial
         \fi
         \def\@tempa{.}%
         \@csc@t\@tempa\@temp@initial\@tempa
         \@csc@t\@tempname\@tempname\@tempa
      \fi}%
   \@split@by@space@result
   \expandafter\endgroup
   \expandafter\def\expandafter#1\expandafter{\@tempname}}
\def\@take@initial@letter@setup{%
   \def~{ }%
   \def\@tempz##1{%
      \ifx##1\@nnil\else
         \def##1{\noexpand##1}%
         \expandafter\@tempz
      \fi}%
   \expandafter\@tempz\@accentlist\@nnil
   \def\a##1{\expandafter\noexpand\csname\string##1\endcsname}%
   \let\@tabacckludge\a
   \def\IeC##1{##1}%
   \let\protect\noexpand}
\def\@take@initial@letter#1{%
   \let\@temp@initial\@empty
   \let\@temp@tail\@empty
   \@take@initial@letter@loop#1\@nnil}
\def\@take@initial@letter@loop{%
   \ifx\@temp@initial\@empty
      \expandafter\@take@initial@letter@loop@
   \else
      \expandafter\@take@initial@letter@finish\expandafter\@empty
   \fi}
\def\@take@initial@letter@finish#1\@nnil{%
   \expandafter\def\expandafter\@tempb\expandafter{#1}%
   \@csc@t\@temp@tail\@temp@tail\@tempb}
\def\@take@initial@letter@loop@{%
   \futurelet\@take@initial@letter@temp\@take@initial@letter@loop@@}
\def\@take@initial@letter@loop@@{%
   \ifx     \@take@initial@letter@temp\@nnil
      \let\@take@initial@letter@next\@gobble
   \else\ifx\@take@initial@letter@temp\bgroup
      \def\@take@initial@letter@next{\@take@initial@letter@bgroup}%
   \else\ifx\@take@initial@letter@temp\@sptoken
      \def\@take@initial@letter@next{\@take@initial@letter@space}%
   \else
      \def\@take@initial@letter@next{\@take@initial@letter@normal}%
   \fi\fi\fi
   \@take@initial@letter@next}
\def\@take@initial@letter@bgroup#1{%
   \begingroup
   \let\@temp@initial\@empty
   \@take@initial@letter@loop#1\@nnil
   \toks@\expandafter{\@temp@initial}%
   \@temptokena\expandafter{\@temp@tail}%
   \edef\@tempa{%
      \def\noexpand\@tempb{{\the\toks@}}%
      \def\noexpand\@tempc{{\the\@temptokena}}}%
   \expandafter\endgroup\@tempa
   \def\@tempd{{}}%
   \ifx\@tempb\@tempd\else \let\@temp@initial\@tempb \fi
   \ifx\@tempc\@tempd\else \@csc@t\@temp@tail\@temp@tail\@tempc \fi
   \@take@initial@letter@loop}
\begingroup
\def\:{\def\@take@initial@letter@space}
\expandafter\endgroup\: {\@take@initial@letter@loop}
\def\@take@initial@letter@normal#1{%
   \ifcat\noexpand#1\noexpand~%
      \expandafter\@take@initial@letter@active@char
   \else
      \expandafter\@take@initial@letter@normal@
   \fi
   #1}
\def\@take@initial@letter@normal@#1{%
   \@tempswafalse
   \def\@tempb{#1}%
   \def\@tempc{\@tfor\@tempc:=}%
   \expandafter\@tempc\@accentlist\do{%
      \ifx\@tempb\@tempc
         \@tempswatrue
         \@break@tfor
      \fi}%
   \if@tempswa
      \def\@take@initial@letter@next{\@take@initial@letter@accent@a#1}%
   \else
      \def\@tempc{\a}%
      \def\@tempd{\@tabacckludge}%
      \def\@take@initial@letter@next{\@take@initial@letter@accent@b}%
      \ifx\@tempb\@tempc\else
         \ifx\@tempb\@tempd\else
            \def\@tempc{\IeC}%
            \ifx\@tempb\@tempc
               \def\@take@initial@letter@next{\@take@initial@letter@accent@IeC}%
            \else
               \def\@take@initial@letter@next{%
                  \def\@temp@initial{#1}%
                  \@take@initial@letter@loop}%
            \fi
         \fi
      \fi
   \fi
   \@take@initial@letter@next}
\def\@take@initial@letter@active@char#1{%
   \begingroup
   \def\@tempc{0}%
   \@tfor\@tempa:=\UTFviii@two@octets\UTFviii@three@octets\UTFviii@four@octets\do{%
      \edef\@tempb{\expandafter\noexpand\@tempa\string#1}%
      \ifx#1\@tempb \let\@tempc\@tempa \fi}%
   \def\UTFviii@two@octets{1}%
   \def\UTFviii@three@octets{2}%
   \def\UTFviii@four@octets{3}%
   \edef\@tempa{\def\noexpand\@take@initial@letter@active@char@argnum{\@tempc}}%
   \expandafter\endgroup\@tempa
   \expandafter\@take@initial@letter@active@char@
      \expandafter{\@take@initial@letter@active@char@argnum}{#1}}
\def\@take@initial@letter@active@char@#1#2{%
   \begingroup
   \count@#1\relax
   \ifnum\count@>\z@
      \advance\count@\m@ne
      \expandafter\def\expandafter\@tempa\expandafter{%
         \expandafter\@take@initial@letter@active@char@@
         \expandafter{\the\count@}{#2}}%
   \else
      \def\@tempa{\@take@initial@letter@normal@{#2}}%
   \fi
   \expandafter\endgroup\@tempa}
\def\@take@initial@letter@active@char@@#1#2#3{%
   \@take@initial@letter@active@char@{#1}{#2#3}}
\def\@take@initial@letter@accent@a#1#2{%
   \def\@temp@initial{#1{#2}}%
   \@take@initial@letter@loop}
\def\@take@initial@letter@accent@b#1#2{%
   \expandafter\def\expandafter\@temp@initial\expandafter{\csname\string#1\endcsname{#2}}%
   \@take@initial@letter@loop}
\def\@take@initial@letter@accent@IeC#1{\@take@initial@letter@loop#1}
\def\@check@By#1{%
   \def\@tempz##1By##2\@nil{\def\@tempa{##1}}%
   \expandafter\@tempz#1By\@nil
   \ifx\@tempa\@empty%%% given-name-part begins with ``By''
      \def\@tempa{By }%
      \def\@tempb{By}%
      \ifx#1\@tempa\else
         \ifx#1\@tempb
            \let#1\@tempa
         \else
            \ClassWarning{jmsj}{%
               Redundant ``By'' in \string\author\space is removed.\MessageBreak
               If the removed ``By'' is a part of an author name,\MessageBreak
               then apply \string\textsc\space to surname}%
            \def\@tempz By##1\@nil{\def#1{##1}}%
            \expandafter\@tempz#1\@nil
            \@remove@top@spaces#1%
            \ifx#1\@tempb \let#1\@tempa \fi
         \fi
      \fi
   \fi}
\def\@put@thanks{%
   \markboth{\@@authors@for@head}{\@title@for@head}%
   \ifx\@subjclass\@empty\else
      \footnotetext[0]{\@subjclass}%
   \fi
   \ifx\@keywords\@empty\else
%%	      \footnotetext[0]{\textit{Key Words and Phrases.}\quad \@keywords.}%
      \footnotetext[0]{\textit{Key\kern1ex Words\kern1ex and\kern1ex Phrases.}\hskip6pt \@keywords.}% v1.3: changed
   \fi
   \ifx\@funding\@empty\else
%%	      \footnotetext[0]{\@funding.}%
      \footnotetext[0]{\@funding}% v1.3: changed
   \fi}
\def\issueinfo#1#2#3#4{%
   \Vol{#1}%
   \No{#2}%
   \Year{#4}}
\def\Vol#1{\gdef\@Vol{#1}}
\def\No#1{\gdef\@No{#1}}
\def\Year#1{\gdef\@Year{#1}}
\issueinfo{00}{0}{Xxxx}{XXXX}
\def\jmsj#1#2{%
   \gdef\@VolNoYear{#1}%
   \DOI{#2}}
\def\DOI#1{\gdef\@DOI{#1}}
\global\let\@VolNoYear\@empty
\global\let\@DOI\@empty
\newcommand*{\copyrightinfo}[2]{%
  \def\copyrightyear{#1}%
  \@ifnotempty{#2}{\def\copyrightholder{#2}}}
\copyrightinfo{0000}{(copyright holder)}
\def\pagespan#1#2{%
  \gdef\@firstpage{#1}%
  \gdef\@lastpage{#2}}
\pagespan{}{}
\newbox\abstractbox \setbox\abstractbox\box\voidb@x
\def\abstract{%
   \def\@tempa{abstract}%
   \ifx\@currenvir\@tempa \expandafter\@abstract
   \else                  \expandafter\@old@abstract
   \fi}
\def\@old@abstract#1{\@abstract#1\endabstract}
\def\@abstract{%
   \ifx\maketitle\relax
      \ClassWarning{jmsj}{Abstract should precede \protect\maketitle}%
      \def\@after@abstract{%
         \ifhmode \unskip\par \fi
         \unvbox\abstractbox}%
   \else
      \let\@after@abstract\relax
   \fi
   \global\setbox\abstractbox\vbox\bgroup\@abstract@set@hsize
      \fontsize{8pt}{10pt}\selectfont
      \parindent=16pt\relax
      \leavevmode \vrule height10pt width\z@
         {\fontsize{8.5pt}{10pt}\bfseries Abstract.}%
%%	         \quad
         \hskip8.5pt% v1.3: changed
         }
\def\endabstract{%
   \ifhmode \unskip\par \fi \vskip-\lastskip\egroup
   \@after@abstract}
\def\@abstract@set@hsize{%
   \if@twocolumn \hsize\textwidth \fi
   \leftskip=17mm \rightskip=17mm\relax}
\def\titlepage{%
   \clearpage
   \thispagestyle{empty}\setcounter{page}{0}}
\def\endtitlepage{\newpage}
%
\renewcommand\theenumi{\@arabic\c@enumi}
\renewcommand\theenumii{\@alph\c@enumii}
\renewcommand\theenumiii{\@roman\c@enumiii}
\renewcommand\theenumiv{\@Alph\c@enumiv}
\def\theenumi{\@arabic\c@enumi}
\def\theenumii{\@alph\c@enumii}
\def\theenumiii{\@roman\c@enumiii}
\def\theenumiv{\@Alph\c@enumiv}
\def\labelenumi{\textup{\theenumi.}}
\def\labelenumii{\textup{(\theenumii)}}
\def\labelenumiii{\textup{\theenumiii.}}
\def\labelenumiv{\textup{\theenumiv.}}
\def\p@enumii{\theenumi}
\def\p@enumiii{\theenumi(\theenumii)}
\def\p@enumiv{\p@enumiii\theenumiii}
\def\labelitemi{\textbullet}
\def\labelitemii{\normalfont\bfseries \textendash}
\def\labelitemiii{\textasteriskcentered}
\def\labelitemiv{\textperiodcentered}
\def\verse{%
   \let\\\@centercr
   \list{}{\itemsep      \z@
           \itemindent   -1.5em%
           \listparindent\itemindent
           \rightmargin  \leftmargin
           \advance\leftmargin 1.5em}%
   \item\relax}
\let\endverse\endlist
\def\quotation{%
   \list{}{\listparindent 1.5em%
           \itemindent    \listparindent
           \rightmargin   \leftmargin
           \parsep        \z@ \@plus\p@}%
    \item\relax}
\let\endquotation\endlist
\def\quote{\list{}{\rightmargin\leftmargin} \item\relax}
\let\endquote\endlist
\def\description{%
   \list{}{\labelwidth\z@ \itemindent-\leftmargin
           \let\makelabel\descriptionlabel}}
\let\enddescription\endlist
\def\descriptionlabel#1{\hspace\labelsep \normalfont\bfseries #1}
\let\upn=\textup
\providecommand*\@upn{\textup}
%
%%% \[...\], eqnarray
\def\eqnarray{%
   \stepcounter{equation}%
   \def\@currentlabel{\p@equation\theequation}%
   \global\@eqnswtrue
  \m@th
   \global\@eqcnt\z@
   \tabskip\@centering
   \let\\\@eqncr
   $$\everycr{}\halign to\displaywidth\bgroup
       \hskip\@centering$\displaystyle\tabskip\z@skip{##}$\@eqnsel
      &\global\@eqcnt\@ne \hfil$\displaystyle{{}##{}}$\hfil
      &\global\@eqcnt\tw@ $\displaystyle{##}$\hfil\tabskip\@centering
      &\global\@eqcnt\thr@@ \hb@xt@\z@\bgroup\hss##\egroup
         \tabskip\z@skip
      \cr}
\@ifclasswith{jmsj}{fleqn}%
   {\let\@tempa\@iden
    \AtBeginDocument{\mathindent\leftmargini}}%
   {\let\@tempa\@gobble}%
\@ifpackageloaded{amsmath}%
   {\let\@tempa\@gobble
    \allowdisplaybreaks[4]}%
   {\@ifpackageloaded{amstex}{\let\@tempa\@gobble}{}}
\@tempa{%
  \def\[{\relax
    \ifmmode\@badmath
    \else
      \begin{trivlist}%
      \@beginparpenalty\predisplaypenalty
      \@endparpenalty\postdisplaypenalty
      \item[]\leavevmode
      \hbox to\linewidth\bgroup$\displaystyle
      \hskip\mathindent\bgroup
    \fi}%
  \def\]{\relax
    \ifmmode
      \egroup \m@th$\hfil \egroup
      \end{trivlist}%
    \else \@badmath
    \fi}%
  \renewenvironment{equation}{%
    \@beginparpenalty\predisplaypenalty
    \@endparpenalty\postdisplaypenalty
    \refstepcounter{equation}%
    \@topsep\abovedisplayskip \trivlist
    \item[]\leavevmode
    \hbox to\linewidth\bgroup\hskip\mathindent$\displaystyle
  }{%
    \m@th$\hfil \displaywidth\linewidth \hbox{\@eqnnum}\egroup
    \endtrivlist
  }%
  \def\eqnarray{%
      \stepcounter{equation}%
      \def\@currentlabel{\p@equation\theequation}%
      \global\@eqnswtrue
      \m@th
      \global\@eqcnt\z@
      \tabskip\mathindent
      \let\\\@eqncr
      $$\everycr{}\halign to\displaywidth\bgroup
          \hskip\@centering$\displaystyle\tabskip\z@skip{##}$\@eqnsel
         &\global\@eqcnt\@ne \hfil$\displaystyle{{}##{}}$\hfil
         &\global\@eqcnt\tw@ $\displaystyle{##}$\hfil\tabskip\@centering
         &\global\@eqcnt\thr@@ \hb@xt@\z@\bgroup\hss##\egroup
            \tabskip\z@skip
         \cr}%
  \newdimen\mathindent
  \mathindent\leftmargini}
%%	\def\emptyset{\mbox{\large$\varnothing$}}% v1.3: invalided
%
%%% sectioning
\def\sectionpunct#1#2{%
   \expandafter\def\csname @seccnt@postfix@#1\endcsname{#2}%
   \expandafter\def\csname @seccnt@afterskip@#1\endcsname{\ }}
\def\sectiondot#1{%
   \expandafter\def\csname @seccnt@postfix@#1\endcsname{.}%
   \expandafter\def\csname @seccnt@afterskip@#1\endcsname{\quad}}
\def\sectionprefix#1#2{%
   \expandafter\def\csname @seccnt@prefix@#1\endcsname{#2}}
\def\@seccntformat#1{%
   \@nameuse{@seccnt@prefix@#1}%
   \@nameuse{the#1}%
   \@nameuse{@seccnt@postfix@#1}%
   \@nameuse{@seccnt@afterskip@#1}}
\@namedef{@seccnt@prefix@section}{}
\@namedef{@seccnt@prefix@subsection}{}
\@namedef{@seccnt@prefix@subsubsection}{}
\@namedef{@seccnt@prefix@paragraph}{}
\@namedef{@seccnt@prefix@subparagraph}{}
\@namedef{@seccnt@postfix@section}{.}
\@namedef{@seccnt@postfix@subsection}{.}
\@namedef{@seccnt@postfix@subsubsection}{.}
\@namedef{@seccnt@postfix@paragraph}{.}
\@namedef{@seccnt@postfix@subparagraph}{.}
\@namedef{@seccnt@afterskip@section}{\quad}
\@namedef{@seccnt@afterskip@subsection}{\quad}
\@namedef{@seccnt@afterskip@subsubsection}{\quad}
\@namedef{@seccnt@afterskip@paragraph}{\quad}
\@namedef{@seccnt@afterskip@subparagraph}{\quad}
%
\setcounter{secnumdepth}{3}
\newcounter{part}
\newcounter{section}
\newcounter{subsection}[section]
\newcounter{subsubsection}[subsection]
\newcounter{paragraph}[subsubsection]
\newcounter{subparagraph}[paragraph]
\renewcommand \thepart {\@Roman\c@part}
\renewcommand \thesection {\@arabic\c@section}
\renewcommand\thesubsection   {\thesection.\@arabic\c@subsection}
\renewcommand\thesubsubsection{\thesubsection.\@arabic\c@subsubsection}
\renewcommand\theparagraph    {\thesubsubsection.\@arabic\c@paragraph}
\renewcommand\thesubparagraph {\theparagraph.\@arabic\c@subparagraph}
\def\@part[#1]#2{%
    \ifnum \c@secnumdepth >\m@ne
      \refstepcounter{part}%
      \addcontentsline{toc}{part}{\thepart\hspace{1em}#1}%
    \else
      \addcontentsline{toc}{part}{#1}%
    \fi
    {\parindent \z@ \raggedright
     \interlinepenalty \@M
     \normalfont
     \ifnum \c@secnumdepth >\m@ne
       \Large\bfseries \partname\nobreakspace\thepart
       \par\nobreak
     \fi
     \huge \bfseries #2%
     \markboth{}{}\par}%
    \nobreak
    \vskip 3ex
    \@afterheading}
\def\@spart#1{%
    {\parindent \z@ \raggedright
     \interlinepenalty \@M
     \normalfont
     \huge \bfseries #1\par}%
     \nobreak
     \vskip 3ex
     \@afterheading}
\def\section{%
%%	   \@startsection{section}{1}{15pt}{5mm}{2.5mm}%
   \@startsection{section}{1}{\normalparindent}{5mm}{2.5mm}% v1.3: changed
   {\normalfont\normalsize\bfseries\boldmath}}
\def\subsection{%
%%	   \@startsection{subsection}{2}{15pt}{2.5mm}{1sp}%
   \@startsection{subsection}{2}{\normalparindent}{2.5mm}{1sp}% v1.3: changed
   {\normalfont\normalsize\bfseries\boldmath}}
\def\subsubsection{%
%%	   \@startsection{subsubsection}{3}{15pt}%
%%	   {\z@ \@plus\p@ \@minus.5\p@}{1sp}%
   \@startsection{subsubsection}{3}{\normalparindent}{2.5mm}{1sp}% v1.3: changed
   {\normalfont\normalsize\bfseries\boldmath}}
\def\paragraph{%
%%	   \@startsection{paragraph}{4}{15pt}%
   \@startsection{paragraph}{4}{\normalparindent}% v1.3: changed
   {\z@ \@plus\p@ \@minus.5\p@}{-1em}
   {\normalfont\normalsize\bfseries\boldmath}}
\def\subparagraph{% v1.3: changed
%%	   \@startsection{subparagraph}{5}{15pt}%
   \@startsection{subparagraph}{5}{\normalparindent}% v1.3: changed
   {\z@ \@plus\p@ \@minus.5\p@}{-1em}
   {\normalfont\normalsize\bfseries\boldmath}}
\def\appendix{%
   \par
   \c@section\z@
   \c@subsection\z@
   \def\thesection{\@Alph\c@section}}
\def\@Roman#1{\expandafter\@slowromancap \romannumeral#1@}%
\def\@slowromancap#1{\ifx @#1% then terminate
  \else
    \if i#1I\else\if v#1V\else\if x#1X\else\if l#1L\else\if
    c#1C\else\if m#1M\else#1\fi\fi\fi\fi\fi\fi
    \expandafter\@slowromancap
  \fi}
\newcommand\@pnumwidth{1.55em}
\newcommand\@tocrmarg{2.55em}
\newcommand\@dotsep{4.5}
\setcounter{tocdepth}{3}
\newcommand\tableofcontents{%
    \section*{\contentsname
        \@mkboth{%
           \MakeUppercase\contentsname}{\MakeUppercase\contentsname}}%
    \@starttoc{toc}%
    }
\newcommand*\l@part[2]{%
  \ifnum \c@tocdepth >-2\relax
    \addpenalty\@secpenalty
    \addvspace{2.25em \@plus\p@}%
    \setlength\@tempdima{3em}%
    \begingroup
      \parindent \z@ \rightskip \@pnumwidth
      \parfillskip -\@pnumwidth
      {\leavevmode
       \large \bfseries #1\hfil \hb@xt@\@pnumwidth{\hss #2}}\par
       \nobreak
       \if@compatibility
         \global\@nobreaktrue
         \everypar{\global\@nobreakfalse\everypar{}}%
      \fi
    \endgroup
  \fi}
\newcommand*\l@section[2]{%
  \ifnum \c@tocdepth >\z@
    \addpenalty\@secpenalty
    \addvspace{1.0em \@plus\p@}%
    \setlength\@tempdima{1.5em}%
    \begingroup
      \parindent \z@ \rightskip \@pnumwidth
      \parfillskip -\@pnumwidth
      \leavevmode \bfseries
      \advance\leftskip\@tempdima
      \hskip -\leftskip
      #1\nobreak\hfil \nobreak\hb@xt@\@pnumwidth{\hss #2}\par
    \endgroup
  \fi}
\newcommand*\l@subsection{\@dottedtocline{2}{1.5em}{2.3em}}
\newcommand*\l@subsubsection{\@dottedtocline{3}{3.8em}{3.2em}}
\newcommand*\l@paragraph{\@dottedtocline{4}{7.0em}{4.1em}}
\newcommand*\l@subparagraph{\@dottedtocline{5}{10em}{5em}}
\newcommand\listoffigures{%
    \section*{\listfigurename}%
      \@mkboth{\MakeUppercase\listfigurename}%
              {\MakeUppercase\listfigurename}%
    \@starttoc{lof}%
    }
\newcommand*\l@figure{\@dottedtocline{1}{1.5em}{2.3em}}
\newcommand\listoftables{%
    \section*{\listtablename}%
      \@mkboth{%
          \MakeUppercase\listtablename}%
         {\MakeUppercase\listtablename}%
    \@starttoc{lot}%
    }
\let\l@table\l@figure
%
%%% bibliography

% v1.3: added
\def\@biblabel#1{%
  \setbox\z@\hbox{#1}\relax%
  \dimen0=\wd0\relax%
  \setbox2\hbox{99}\relax%
  \dimen2=\wd2\relax%
  \ifdim\dimen0<\dimen2
    [\hbox to\wd2{\hss#1\hss}]%
  \else
    [#1]%
  \fi
}

\newdimen\bibindent
\setlength\bibindent{1.5em}
\def\refname{References}
\def\thebibliography#1{%
   \@place@acknowledgements
   \global\let\presectionname\relax
   \global\let\postsectionname\relax
%%	   \section*{\hfil \hspace*{-15pt}\refname \hfil}%
   \section*{\hfil \hspace*{-\normalparindent}\refname \hfil}% v1.3: changed
   \list{\@biblabel{\@arabic\c@enumiv}}%
        {%
         \fontsize{8pt}{3.7mm}\selectfont% v1.3: changed
         \settowidth\labelwidth{\@biblabel{#1}}%
         \labelsep=9.8pt\relax% v1.3: added
         \leftmargin\labelwidth
         \advance\leftmargin\labelsep
         \topsep\z@\parsep\z@\itemsep\z@\partopsep\z@
%%	         \fontsize{8pt}{10pt}\selectfont
         \@openbib@code
         \usecounter{enumiv}%
         \let\p@enumiv\@empty
         \renewcommand\theenumiv{\@arabic\c@enumiv}}%
   \sloppy
   \clubpenalty4000
   \@clubpenalty\clubpenalty
   \widowpenalty4000%
   \sfcode`\.\@m}
\def\endthebibliography{%
   \def\@noitemerr{\@latex@warning{Empty `thebibliography' environment}}%
   \endlist}
\def\@cite#1#2{\textnormal{[{\bfseries #1}\if@tempswa, #2\fi]}}
\def\bysame{\leavevmode\hbox to3em{\hrulefill}\thinspace}
\def\newblock{}
\let\@openbib@code\@empty
\def\@place@acknowledgements{%
   \begingroup
   \@tempswafalse
   \let\@temptext\@empty
   \count@\z@
   \@whilenum\count@<\@authorid\do{%
      \advance\count@\@ne
      \expandafter\ifx\csname @thanks@\the\count@\endcsname\relax\else
         \expandafter\ifx\csname @thanks@\the\count@\endcsname\@empty\else
            \@tempswatrue
            \expandafter\let\expandafter\@tempa\csname @thanks@\the\count@\endcsname
            \expandafter\def\expandafter\@tempa\expandafter{\@tempa\par}%
            \@csc@t\@temptext\@temptext\@tempa
         \fi
      \fi}%
      \if@tempswa
         \ifhmode \unskip\par \fi
         \addvspace{\medskipamount}%
         \normalsize
         \noindent\hspace{\normalparindent}%
         \textsc{Acknowledgements.}\quad\@temptext
      \fi
   \endgroup}
%%%
\def\MR#1{%
   \relax
   \ifhmode\unskip\spacefactor3000 \space\fi
   MR~\MRhref{#1}{#1}}
\let\MRhref\@gobble
\def\URL{%
   \begingroup
   \def\@sverb##1{%
     \def\@tempa####1##1{\@URL{####1}\egroup\endgroup}%
     \@tempa}%
   \verb}
\let\URLhref\@gobble
\def\@URL#1{\URLhref{#1}#1}
%
\newif\if@restonecol
\newenvironment{theindex}%
   {\if@twocolumn \@restonecolfalse \else \@restonecoltrue \fi
    \twocolumn[\section*{\indexname}]%
    \@mkboth{\MakeUppercase\indexname}{\MakeUppercase\indexname}%
    \thispagestyle{plain}\parindent\z@
    \parskip\z@ \@plus .3\p@\relax
    \columnseprule \z@
    \columnsep 35\p@
    \let\item\@idxitem}
  {\if@restonecol\onecolumn\else\clearpage\fi}
\def\@idxitem{\par\hangindent 40\p@}
\def\subitem{\@idxitem \hspace*{20\p@}}
\def\subsubitem{\@idxitem \hspace*{30\p@}}
\def\indexspace{\par \vskip 10\p@ \@plus5\p@ \@minus3\p@\relax}
\def\seeonlyname{see}
\def\seename{see also}
\def\alsoname{see also}
\def\seeonly#1#2{\emph{\seeonlyname} #1}
\def\see#1#2{\emph{\seename} #1}
\def\seealso#1#2{\emph{\alsoname} #1}
\def\printindex{\@input{\jobname.ind}}
\DeclareRobustCommand\textprime{\leavevmode
  \raise.8ex\hbox{\check@mathfonts\the\scriptfont2 \char48 }}
\@addtoreset{footnote}{chapter}
\def\footnoterule{\kern-.3\p@
        \hrule\@width 120pt\kern2.8\p@}
\def\@makefnmark{%
   \leavevmode
   \hbox{\@textsuperscript{\normalfont\@thefnmark}}}
\long\def\@makefntext#1{%
   \parindent 14pt\relax
   \noindent\hbox to 1.5em{\hss\@makefnmark}#1}
\def\thefootnote{\ifnum\c@footnote>\z@ \number\c@footnote\fi}
\hfuzz=1pt \vfuzz=\hfuzz
%
%%% theorem
\def\theoremstyle#1{%
  \@ifundefined{th@#1}{%
    \ClassWarning{jsmj}{Unknown theoremstyle `#1'}%
    \thm@style{plain}}
  {\thm@style{#1}}}
\newtoks\thm@style%plain style
\thm@style{plain}
\newtoks\thm@bodyfont  \thm@bodyfont{\itshape}
\newtoks\thm@headfont  \thm@headfont{\scshape}
\newtoks\thm@notefont  \thm@notefont{}
\newtoks\thm@headpunct \thm@headpunct{.}
\newskip\thm@preskip \newskip\thm@postskip
\def\thm@space@setup{\thm@preskip 9pt \thm@postskip=\thm@preskip}
\def\th@remark{%%remark style
  \thm@headfont{\scshape}%
  \normalfont % body font
  \thm@preskip 17pt \divide\thm@preskip\tw@
  \thm@postskip\thm@preskip}
\let\thm@indent\indent
\def\qed{\hfill$\square$\vskip9pt}
\def\@thm#1#2#3{%
  \ifhmode\unskip\unskip\par\fi
  \normalfont
  \trivlist
  \let\thmheadnl\relax
  \let\thm@swap\@gobble
  \thm@headpunct{.}% add period after heading
  \thm@headsep 12\p@ plus\p@ minus\p@\relax
  \thm@space@setup
  #1% style overrides
  \@topsep \thm@preskip               % used by thm head
  \@topsepadd \thm@postskip           % used by \@endparenv
  \def\@tempa{#2}\ifx\@empty\@tempa
    \def\@tempa{\@oparg{\@begintheorem{#3}{}}[]}%
  \else
    \refstepcounter{#2}%
    \def\@tempa{\@oparg{\@begintheorem{#3}{\csname the#2\endcsname}}[]}%
  \fi
  \@tempa}
\renewcommand{\proofname}{\textsc{Proof}}
\newenvironment{Proof}[1][\proofname]{\par
  \pushQED{\qed}%
  \normalfont \topsep8\p@\@plus12\p@\relax
  \trivlist
  \item[\hskip\labelsep
        \scshape
%%	   \indent 
   \hbox to\normalparindent{\hss}% v1.3: changed
   #1\@addpunct{.}\ \ ]\ignorespaces}%
  {\popQED\endtrivlist\@endpefalse}
\providecommand{\proofname}{Proof}
\def\nonslanted{%
   \relax
   \expandafter\let\expandafter\@tempa\csname\f@shape shape\endcsname
   \ifx\@tempa\itshape\upshape
   \else\ifx\@tempa\slshape\upshape\fi\fi}

% v1.3: added
\renewcommand{\qedsymbol}{\textsquare}
\DeclareRobustCommand{\qed}{%
  \ifmmode \mathqed
  \else
    \leavevmode\unskip\penalty9999 \hbox{}\nobreak\hfill
    \quad
    \hbox{\qedsymbol}%
  \fi
}
\let\split=\aligned
\let\endsplit=\endaligned
\let\proof\Proof
\let\endproof\endProof

%
%%% floats
\newskip\abovecaptionskip \abovecaptionskip\z@
\newskip\belowcaptionskip \belowcaptionskip\z@
\setcounter{topnumber}{4}
\setcounter{bottomnumber}{4}
\setcounter{totalnumber}{4}
\setcounter{dbltopnumber}{4}
\renewcommand{\topfraction}{.97}
\renewcommand{\bottomfraction}{.97}
\renewcommand{\textfraction}{.03}
\renewcommand{\floatpagefraction}{.9}
\renewcommand{\dbltopfraction}{.97}
\renewcommand{\dblfloatpagefraction}{.9}
\setlength\floatsep    {12\p@ \@plus 2\p@ \@minus 2\p@}
\setlength\textfloatsep{20\p@ \@plus 2\p@ \@minus 4\p@}
\setlength\intextsep   {12\p@ \@plus 2\p@ \@minus 2\p@}
\setlength\dblfloatsep    {12\p@ \@plus 2\p@ \@minus 2\p@}
\setlength\dbltextfloatsep{20\p@ \@plus 2\p@ \@minus 4\p@}
\setlength\@fptop{0\p@ \@plus 1fil}
\setlength\@fpsep{8\p@ \@plus 2fil}
\setlength\@fpbot{0\p@ \@plus 1fil}
\setlength\@dblfptop{0\p@ \@plus 1fil}
\setlength\@dblfpsep{8\p@ \@plus 2fil}
\setlength\@dblfpbot{0\p@ \@plus 1fil}
\def\@floatenv{\let\center\Center}
\def\Center{\topsep\z@\parsep\z@\itemsep\z@\partopsep\z@
   \trivlist \centering\item\relax}
\def\endCenter{\endtrivlist}
\newcommand{\fps@figure}{tbp}
\newcommand{\fps@table}{tbp}
\newcounter{figure}
\def\ftype@figure{1}
\def\ext@figure{lof}
\def\fnum@figure{\figurename\ \thefigure}
\def\figurename{Figure}
\newenvironment{figure}%
   {\@floatenv\abovecaptionskip4mm\belowcaptionskip\z@\@float{figure}}%
   {\end@float}
\newenvironment{figure*}%
   {\@floatenv\abovecaptionskip4mm\belowcaptionskip\z@\@dblfloat{figure}}
   {\end@dblfloat}
\newcounter{table}
\def\ftype@table{2}
\def\ext@table{lot}
\def\fnum@table{\tablename\ \thetable}
\def\tablename{Table}
\newenvironment{table}%
   {\@floatenv\abovecaptionskip\z@\belowcaptionskip4mm\@float{table}}%
   {\end@float}
\newenvironment{table*}%
   {\@floatenv\abovecaptionskip\z@\belowcaptionskip4mm\@dblfloat{table}}%
   {\end@dblfloat}
\def\@floatboxreset{\global\@minipagefalse}
\long\def\@makecaption#1#2{%
   \vskip\abovecaptionskip
   \setbox\@tempboxa\hbox{\small #1\@captiondelim #2}%
   \ifdim \wd\@tempboxa>0.8\hsize
      \leavevmode
%%	      \hfill\parbox[t]{0.8\hsize}{#1\@captiondelim #2}\hfill\par
      \hfil\parbox[t]{0.8\hsize}{\unhbox\@tempboxa}\par% v1.3: changed
   \else
      \global \@minipagefalse
      \hb@xt@\hsize{\hfil\box\@tempboxa\hfil}%
   \fi
   \vskip\belowcaptionskip}
\def\captiondelim#1{\def\@captiondelim{#1}}
\captiondelim{.\quad}
\def\nonbreakingspace{\unskip\nobreak\ \ignorespaces}
\def~{\protect\nonbreakingspace}

% v1.3: changed
%%	\def\@biblabel#1{\@ifnotempty{#1}{[#1]}}
%%	\def\@citestyle{\m@th\upshape\mdseries}
%%	\let\citeform\@firstofone
%%	\def\@cite#1#2{{%
%%	  \@citestyle[\citeform{#1}\if@tempswa, #2\fi]}}
%%	\@ifundefined{cite }{%
%%	  \expandafter\let\csname cite \endcsname\cite
%%	  \edef\cite{\noexpand\protect\expandafter\noexpand\csname cite \endcsname}%
%%	}{}
\def\@citestyle{\m@th\upshape\mdseries}
\def\citeform#1{{\bfseries#1}}
\def\@cite#1#2{{\@citestyle[\citeform{#1}\if@tempswa, #2\fi]}}

%%% misc
\@ifpackageloaded{amsmath}{%
  \def\math@qedhere{%
     \@ifundefined{\@currenvir @qed}%
        {\qed@warning\quad\hbox{\qedsymbol}}%
        {\expandafter\aftergroup\csname\@currenvir @qed\endcsname}}%
  \def\displaymath@qed{%
     \relax
     \ifmmode
        \ifinner \aftergroup\linebox@qed
        \else
           \eqno
           \let\eqno\relax \let\leqno\relax \let\veqno\relax
           \hbox{\qedsymbol}%
        \fi
     \else
        \aftergroup\linebox@qed
     \fi}
  \expandafter\let\csname equation*@qed\endcsname\displaymath@qed
  \def\equation@qed{%
     \iftagsleft@
        \hbox{\phantom{\quad\qedsymbol}}%
        \gdef\alt@tag{%
           \rlap{\hbox to\displaywidth{\hfil\qedsymbol}}%
           \global\let\alt@tag\@empty}%
     \else
        \gdef\alt@tag{%
           \global\let\alt@tag\@empty
           \vtop{\ialign{\hfil####\cr \tagform@\theequation\cr \qedsymbol\cr}}%
           \setbox\z@}%
     \fi}
  \def\qed@tag{%
     \global\tag@true \nonumber
     &\omit\setbox\z@\hbox{\strut@ \qedsymbol}\tagsleft@false
     \place@tag@gather
     \kern-\tabskip
     \ifst@rred \else \global\@eqnswtrue \fi \global\advance\row@\@ne \cr}
  \def\split@qed{%
     \def\endsplit{\crcr\egroup \egroup \ctagsplit@false \rendsplit@
        \aftergroup\align@qed}}
  \def\align@qed{%
     \ifmeasuring@ \tag*{\qedsymbol}%
     \else \let\math@cr@@@\qed@tag
     \fi}
  \expandafter\let\csname align*@qed\endcsname\align@qed
  \expandafter\let\csname gather*@qed\endcsname\align@qed}%%% for amsmath
{\def\math@qedhere{%
     \@ifundefined{\@currenvir @qed}%
        {\qed@warning \aftergroup\displaymath@qed}%
        {\expandafter\aftergroup\csname\@currenvir @qed\endcsname}}
  \def\displaymath@qed{%
     \relax
     \ifmmode
        \ifinner \aftergroup\aftergroup\aftergroup\linebox@qed
        \else
           \eqno \def\@badmath{$$}%
           \let\eqno\relax \let\leqno\relax \let\veqno\relax
           \hbox{\qedsymbol}%
        \fi
     \else
        \aftergroup\linebox@qed
     \fi}
   \@ifundefined{ver@leqno.clo}%
      {\def\equation@qed{\displaymath@qed \quad}}%
      {\def\equation@qed{\displaymath@qed}}%
   \def\@tempa#1$#2#3\@nil{\def\[{#1$#2\def\@currenvir{displaymath}#3}}%
   \expandafter\@tempa\[\@nil}%%% for plain LaTeX
\providecommand*{\openbox}{\leavevmode
   \hbox to.77778em{%
   \hfil\vrule
   \vbox to.675em{\hrule width.6em\vfil\hrule}%
   \vrule\hfil}}
\DeclareRobustCommand{\textsquare}{%
  \begingroup \usefont{U}{msa}{m}{n}\thr@@\endgroup}
\@ifclasswith{jmsj}{noamsfonts}{\providecommand{\qedsymbol}{\openbox}}{}
\providecommand{\qedsymbol}{\textsquare}
\def\markleft#1{{\let\protect\noexpand
   \let\label\relax \let\index\relax \let\glossary\relax
   \expandafter\@markleft\@themark{#1}%
   \mark{\@themark}}%
   \if@nobreak\ifvmode\nobreak\fi\fi}
\def\@markleft#1#2#3{\gdef\@themark{{#3}{#2}}}
\def\@tempa{}
\edef\@dh{\noexpand\mathhexbox{\hexnumber@\symAMSb}67}
\DeclareTextCommand{\dh}{OT1}{%
   \edef\@tempb{\scdefault}%
   \ifx\f@shape\@tempb
      \leavevmode
      \raisebox{-.8ex}{\makebox[\z@][l]{\hskip-.08em\accent"16\hss}}d%
   \else
     \@dh
   \fi}
\DeclareTextCommand{\DH}{OT1}{%
   \leavevmode\raisebox{-.5ex}{\makebox[\z@][l]{\hskip-.07em\accent"16\hss}}D}
\DeclareTextCommand{\DJ}{OT1}{%
   \leavevmode\raisebox{-.5ex}{\makebox[\z@][l]{\hskip-.07em\accent"16\hss}}D}
\DeclareTextCommand{\dj}{OT1}{%
   \edef\@tempa{\f@shape}\edef\@tempb{\scdefault}%
   \ifx\@tempa\@tempb
      \leavevmode
      \raisebox{-.75ex}{\makebox[\z@][l]{\hskip-.08em\accent"16\hss}}d%
   \else
     \leavevmode\raisebox{.02ex}{\makebox[\z@][l]{\hskip.1em\accent"16\hss}}d%
   \fi}
%
%%% hyphenation exceptions
\hyphenation{acad-e-my acad-e-mies af-ter-thought anom-aly anom-alies
an-ti-deriv-a-tive an-tin-o-my an-tin-o-mies apoth-e-o-ses
apoth-e-o-sis ap-pen-dix ar-che-typ-al as-sign-a-ble as-sist-ant-ship
as-ymp-tot-ic asyn-chro-nous at-trib-uted at-trib-ut-able bank-rupt
bank-rupt-cy bi-dif-fer-en-tial blue-print busier busiest
cat-a-stroph-ic cat-a-stroph-i-cally con-gress cross-hatched data-base
de-fin-i-tive de-riv-a-tive dis-trib-ute dri-ver dri-vers eco-nom-ics
econ-o-mist elit-ist equi-vari-ant ex-quis-ite ex-tra-or-di-nary
flow-chart for-mi-da-ble forth-right friv-o-lous ge-o-des-ic
ge-o-det-ic geo-met-ric griev-ance griev-ous griev-ous-ly
hexa-dec-i-mal ho-lo-no-my ho-mo-thetic ideals idio-syn-crasy
in-fin-ite-ly in-fin-i-tes-i-mal ir-rev-o-ca-ble key-stroke
lam-en-ta-ble light-weight mal-a-prop-ism man-u-script mar-gin-al
meta-bol-ic me-tab-o-lism meta-lan-guage me-trop-o-lis
met-ro-pol-i-tan mi-nut-est mol-e-cule mono-chrome mono-pole
mo-nop-oly mono-spline mo-not-o-nous mul-ti-fac-eted mul-ti-plic-able
non-euclid-ean non-iso-mor-phic non-smooth par-a-digm par-a-bol-ic
pa-rab-o-loid pa-ram-e-trize para-mount pen-ta-gon phe-nom-e-non
post-script pre-am-ble pro-ce-dur-al pro-hib-i-tive pro-hib-i-tive-ly
pseu-do-dif-fer-en-tial pseu-do-fi-nite pseu-do-nym qua-drat-ic
quad-ra-ture qua-si-smooth qua-si-sta-tion-ary qua-si-tri-an-gu-lar
quin-tes-sence quin-tes-sen-tial re-arrange-ment rec-tan-gle
ret-ri-bu-tion retro-fit retro-fit-ted right-eous right-eous-ness
ro-bot ro-bot-ics sched-ul-ing se-mes-ter semi-def-i-nite
semi-ho-mo-thet-ic set-up se-vere-ly side-step sov-er-eign spe-cious
spher-oid spher-oid-al star-tling star-tling-ly sta-tis-tics
sto-chas-tic straight-est strange-ness strat-a-gem strong-hold
sum-ma-ble symp-to-matic syn-chro-nous topo-graph-i-cal tra-vers-a-ble
tra-ver-sal tra-ver-sals treach-ery turn-around un-at-tached
un-err-ing-ly white-space wide-spread wing-spread wretch-ed
wretch-ed-ly Eng-lish Euler-ian Feb-ru-ary Gauss-ian
Hamil-ton-ian Her-mit-ian Jan-u-ary Japan-ese Kor-te-weg
Le-gendre Mar-kov-ian Noe-ther-ian No-vem-ber Rie-mann-ian Sep-tem-ber}
\let\calclayout\relax
%
\def\rom{\textup}
%
%%% profile
\newif\if@auto@generate@profiles
\global\@auto@generate@profilestrue
\def\profile#1#2{%
   \global\@auto@generate@profilesfalse
   \ifhmode \unskip\par \fi
   \vskip3mm
   \noindent\hfill
   \begingroup\fontsize{8}{11}\selectfont
   \def\arraystretch{1.2}%
   \begin{tabular}[t]{@{}l@{}}
     {\normalsize #1}\\
     #2%
   \end{tabular}
   \endgroup
   \par}
%
% v1.3: added (
\def\@generate@profiles@inlineblocks{%
   \begingroup \fontsize{8}{11}\selectfont
   %
   \newbox\@author@box@left
   \newbox\@author@box@right
   \newdimen\@author@width@left
   \newdimen\@author@width@right
   \newcount\@author@count@even
   %
   \@author@count@even\@authorid
   \@author@width@left\z@
   \@author@width@right\z@
   %
   % authors odd case, caluclate last right column width 
   \ifodd\@author@count@even\relax
     \advance\@author@count@even by -1\relax%
     \count@=\@authorid\relax
     \@generate@profiles@inlineblock\relax
     \setbox\@author@box@right\hbox{\vtop{\@generate@profiles@inlineblock@output}}%
     \@author@width@right\wd\@author@box@right\relax
   \fi%
   %
   % caluclate maximum column width, left column(odd-numbered authors), right column(even-numbered authors)
   \count@\z@
   \@whilenum\count@<\@author@count@even\do{%
      \advance\count@\@ne
      \@generate@profiles@inlineblock
      \ifodd\count@
        \setbox\@author@box@left\hbox{\vtop{\@generate@profiles@inlineblock@output}}%
        \ifdim\@author@width@left<\wd\@author@box@left\relax\@author@width@left=\wd\@author@box@left\fi%
      \else
        \setbox\@author@box@right\hbox{\vtop{\@generate@profiles@inlineblock@output}}%
        \ifdim\@author@width@right<\wd\@author@box@right\relax\@author@width@right=\wd\@author@box@right\fi%
      \fi
   }%
   %
   % typeset authors
   \count@\z@
   \@whilenum\count@<\@author@count@even\do{%
      \advance\count@\@ne
      \@generate@profiles@inlineblock
      %\ifodd\count@\leavevmode\hfill\else\kern3em\fi%
      \ifodd\count@\noindent\hfill\else\kern3em\fi%
      \hbox to\ifodd\count@\@author@width@left\else\@author@width@right\fi{\vtop{\@generate@profiles@inlineblock@output}\hss}%
      \ifodd\count@\else\vskip3mm\fi%
   }%
   %
   % authors odd case, typeset last author
   \ifodd\@authorid%
      \count@\@authorid
      %\leavevmode\hfill%
      \noindent\hfill%
      \@generate@profiles@inlineblock
      \hbox to\@author@width@right{\vtop{\@generate@profiles@inlineblock@output}\hss}%
   \fi
   \endgroup
}
\def\@generate@profiles@inlineblock{%
   \dimen@\profilemaxwidth\relax
   \ifdim\dimen@>\columnwidth \dimen@\columnwidth \fi
   \edef\@profilemaxwidth{\the\dimen@}%
   \setbox\@profile@box\hbox{}%
   \@tempdima\z@
   \setbox\z@\hbox{\normalsize \vphantom{(\'E}\vrule\@width\z@ \@depth6\p@% )
      \csname @normalized@authorname@\the\count@\endcsname}%
   \ifdim\@tempdima<\wd\z@ \@tempdima\wd\z@ \fi
   \setbox\@profile@box\hbox{%
      \box\z@
      \vbox{}%
      \unhbox\@profile@box}%
   \@generate@profiles@{address}{}%
   \@generate@profiles@{curr@address}{}%
   \@generate@profiles@{email}{E-mail: }%
   \@generate@profiles@{urladdr}{}%
}
\def\@generate@profiles@inlineblock@output{%
   \setbox\@profile@box\hbox{\unhbox\@profile@box \global\setbox\@ne\lastbox}%
   \ifvoid\@ne\else
      \ifvbox\@ne
         %\vskip 2mm \@plus  100\p@
         %\penalty\@lowpenalty
         %\vskip \z@ \@plus -100\p@
      \else
         \hbox to\@tempdima{\unhbox\@ne \hfil}%
      \fi
      \expandafter\@generate@profiles@inlineblock@output
   \fi}
% v1.3: added )
\AtEndDocument{%
   \if@auto@generate@profiles
   \ifnum\@authorid=1\vskip2mm\else\vskip4.5mm\fi% v1.3: added
      \if@noskipsec \leavevmode \fi
      \ifhmode \unskip\par \fi
%%	      \@generate@profiles
      \ifnum\@authorid=1\@generate@profiles\else\@generate@profiles@inlineblocks\fi% v1.3: changed
   \fi
   \clearpage
   \count@\c@page \advance\count@\m@ne
   \if@filesw
      \immediate\write\@auxout{\string\newlabel{lastpage}{{}{\the\count@}}}%
   \fi}
\newbox\@profile@box
\def\profilemaxwidth{.667\textwidth}
\def\@generate@profiles{%
   \begingroup \fontsize{8}{11}\selectfont
   \dimen@\profilemaxwidth\relax
   \ifdim\dimen@>\columnwidth \dimen@\columnwidth \fi
   \edef\@profilemaxwidth{\the\dimen@}%
   \setbox\@profile@box\hbox{}%
   \@tempdima\z@
   \count@\z@
   \@whilenum\count@<\@authorid\do{%
      \advance\count@\@ne
      \setbox\z@\hbox{\normalsize \vrule\@width\z@ \@depth6\p@
         \csname @normalized@authorname@\the\count@\endcsname}%
      \ifdim\@tempdima<\wd\z@ \@tempdima\wd\z@ \fi
      \setbox\@profile@box\hbox{%
         \box\z@
         \vbox{}%
         \unhbox\@profile@box}%
      \@generate@profiles@{address}{}%
      \@generate@profiles@{curr@address}{}%
      \@generate@profiles@{email}{E-mail: }%
      \@generate@profiles@{urladdr}{}}%
   \@generate@profiles@output
   \endgroup}
\def\@generate@profiles@#1#2{%
   \expandafter\ifx\csname @#1@\the\count@\endcsname\relax\else
      \expandafter\let\expandafter\@tempa\csname @#1@\the\count@\endcsname
      \ifx\@tempa\@empty\else
         \setbox\z@\vbox{\hsize\@profilemaxwidth \parindent\z@
            \interlinepenalty\z@ \clubpenalty\z@ \widowpenalty\z@
            \def\@gnewline##1{\unskip\nobreak\hfil\break}%
            #2\@tempa%
            \vphantom{(\'E}% v1.3: added
            }%
         \global\setbox\@ne\hbox{}%
         \setbox\z@\vbox{\unvbox\z@ \@generate@profiles@loop}%
         \setbox\tw@\box\@ne
         \@generate@profiles@@
      \fi
   \fi}
\def\@generate@profiles@loop{%
   \unskip \unpenalty \unskip \unpenalty
   \setbox\tw@\lastbox
   \ifvoid\tw@\else
      \ifhbox\tw@
         \global\setbox\@ne\hbox{\unhbox\@ne\hbox{\unhbox\tw@\unskip\unskip}}%
      \fi
      \expandafter\@generate@profiles@loop
   \fi}
\def\@generate@profiles@@{%
   \setbox\tw@\hbox{\unhbox\tw@\global\setbox\@ne\lastbox}%
   \ifvoid\@ne\else
      \ifdim\@tempdima<\wd\@ne \@tempdima\wd\@ne \fi
      \setbox\@profile@box\hbox{\box\@ne \unhbox\@profile@box}%
      \expandafter\@generate@profiles@@
   \fi}
\def\@generate@profiles@output{%
   \setbox\@profile@box\hbox{\unhbox\@profile@box \global\setbox\@ne\lastbox}%
   \ifvoid\@ne\else
      \ifvbox\@ne
         \vskip 3mm \@plus  100\p@
         \penalty\@lowpenalty
         \vskip \z@ \@plus -100\p@
      \else
         \hbox to\hsize{\hfill\hbox to\@tempdima{\unhbox\@ne \hfil}}%
      \fi
      \expandafter\@generate@profiles@output
   \fi}

% v1.3: added (
\newdimen\MatrixEnvColsep
\newdimen\MatrixEnvInsidegap
\MatrixEnvColsep=.4em
\MatrixEnvInsidegap=\z@
\def\env@matrix{\arraycolsep=\MatrixEnvColsep
  \hskip -\arraycolsep\hskip\MatrixEnvInsidegap
  \let\@ifnextchar\new@ifnextchar
  \array{*\c@MaxMatrixCols c}}
\renewenvironment{matrix}{%
  \matrix@check\matrix\env@matrix
}{%
  \endarray \hskip -\arraycolsep\hskip\MatrixEnvInsidegap
}
% [lineno] option: need lineno.sty 
\def\Define@linenomathWithnumbersForBeginAMS{%
  \newcommand\linenomathWithnumbersForBeginAMS{% 210824
    \ifLineNumbers 
      \ifnum\interlinepenalty>-\linenopenaltypar
        \global\holdinginserts\thr@@ 
        \advance\interlinepenalty \linenopenalty
        \ifhmode                                   % v4.3 
          \advance\predisplaypenalty \linenopenalty
        \fi 
%%        \advance\postdisplaypenalty \linenopenalty
        \advance\interdisplaylinepenalty \linenopenalty
      \fi
    \fi
    \ignorespaces
  }%
}%
%
\@ifundefined{@LN}{\let\@LN\@gobbletwo}{}
\if@UseLineno
  \RequirePackage[mathlines]{lineno}[4.41]
% http://phaseportrait.blogspot.com/2007/08/lineno-and-amsmath-compatibility.html
% https://tex.stackexchange.com/questions/461186/how-to-use-lineno-with-amsmath-align
  \Define@linenomathWithnumbersForBeginAMS%
  \newcommand*\patchAmsMathEnvironmentForLineno[1]{%
    \expandafter\let\csname old#1\expandafter\endcsname\csname #1\endcsname
    \expandafter\let\csname oldend#1\expandafter\endcsname\csname end#1\endcsname
    \renewenvironment{#1}%
    {\linenomathWithnumbersForBeginAMS\csname old#1\endcsname}% 210824
    {\csname oldend#1\endcsname\endlinenomath}}% 
  \newcommand*\patchBothAmsMathEnvironmentsForLineno[1]{%
    \patchAmsMathEnvironmentForLineno{#1}%
    \patchAmsMathEnvironmentForLineno{#1*}}%
%  \patchBothAmsMathEnvironmentsForLineno{equation}%
  \patchBothAmsMathEnvironmentsForLineno{align}%
  \patchBothAmsMathEnvironmentsForLineno{flalign}%
  \patchBothAmsMathEnvironmentsForLineno{alignat}%
  \patchBothAmsMathEnvironmentsForLineno{gather}%
  \patchBothAmsMathEnvironmentsForLineno{multline}%
% 210824
  \newcommand*\patchMathEnvironmentForLineno[1]{%
    \expandafter\let\csname old#1\expandafter\endcsname\csname #1\endcsname
    \expandafter\let\csname oldend#1\expandafter\endcsname\csname end#1\endcsname
    \renewenvironment{#1}%
    {\linenomath\csname old#1\endcsname}%
    {\csname oldend#1\endcsname\endlinenomath}}% 
  \newcommand*\patchBothMathEnvironmentsForLineno[1]{%
    \patchMathEnvironmentForLineno{#1}%
    \patchMathEnvironmentForLineno{#1*}}%
  \patchBothMathEnvironmentsForLineno{equation}%
% for multiline
  \def\mmeasure@#1{%
      \begingroup
          \measuring@true
%
          \ifnum-\linenopenaltypar>\interdisplaylinepenalty
            \advance\interdisplaylinepenalty-\linenopenalty
          \fi
%
          \def\label##1{%
            \begingroup\measuring@false\label@in@display{##1}\endgroup}%
          \def\math@cr@@@{\cr}%
          \let\shoveleft\@iden \let\shoveright\@iden
          \savecounters@
          \global\row@\z@
          \setbox\@ne\vbox{%
              \global\let\df@tag\@empty
              \halign{%
                  \setboxz@h{\@lign$\m@th\displaystyle{}##$}%
                  \iftagsleft@
                      \ifnum\row@=\@ne
                          \global\totwidth@\wdz@
                          \global\lineht@\ht\z@
                      \fi
                  \else
                      \global\totwidth@\wdz@
                      \global\lineht@\dp\z@
                  \fi
                  \crcr
                  #1%
                  \crcr
              }%
          }%
          \ifx\df@tag\@empty\else\global\tag@true\fi
          \if@eqnsw\global\tag@true\fi
          \iftag@
              \setboxz@h{%
                  \if@eqnsw
                      \stepcounter{equation}%
                      \tagform@\theequation
                  \else
                      \df@tag
                  \fi
              }%
              \global\tagwidth@\wdz@
              \dimen@\totwidth@
              \advance\dimen@\tagwidth@
              \advance\dimen@\multlinetaggap
              \iftagsleft@\else
                  \if@fleqn
                      \advance\dimen@\@mathmargin
                  \fi
              \fi
              \ifdim\dimen@>\displaywidth
                  \global\shifttag@true
              \else
                  \global\shifttag@false
              \fi
          \fi
          \restorecounters@
      \endgroup
  }
%
  \linenumbersep=1.5em
  \renewcommand{\linenumberfont}{\normalfont\small\ttfamily}
  \pagewiselinenumbers
\fi
% v1.3: added )
\pagestyle{headings}
\pagenumbering{arabic}
\if@twoside \raggedbottom \fi
\if@twocolumn
   \twocolumn
   \sloppy
   \flushbottom
\else
   \onecolumn
\fi
\endinput
